package sos.ambulance_v2.decision;

import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.AmbulanceTeamAgent;
import sos.ambulance_v2.decision.controller.CenterDecision;
import sos.ambulance_v2.decision.states.IHaveBurridness;
import sos.ambulance_v2.decision.states.IHaveDamage;
import sos.ambulance_v2.decision.states.ImDead;
import sos.ambulance_v2.decision.states.ImGoingToDie;
import sos.ambulance_v2.decision.states.ImNearGasStation;
import sos.ambulance_v2.decision.states.ImStuck;
import sos.ambulance_v2.decision.states.NoCom;
import sos.ambulance_v2.decision.states.RescueState;
import sos.ambulance_v2.decision.states.SearchState;
import sos.ambulance_v2.decision.states.SelfDecide;
import sos.ambulance_v2.decision.states.VIrtualRescueState;
import sos.tools.decisionMaker.implementations.stateBased.SOSStateBasedDecisionMaker;
import sos.tools.decisionMaker.implementations.stateBased.StateFeedbackFactory;

public class AmbulanceDecisionMaker extends SOSStateBasedDecisionMaker {

	private final AmbulanceTeamAgent agent;
	private CenterDecision ambDecision;

	public AmbulanceDecisionMaker(AmbulanceTeamAgent agent, StateFeedbackFactory feedbackFactory) {
		super(agent, feedbackFactory, AmbulanceInformationModel.class);
		this.agent = agent;
	}

	@Override
	public void initiateStates() {
		getThinkStates().add(new ImDead(getInfoModel()));
		getThinkStates().add(new IHaveBurridness(getInfoModel()));
		getThinkStates().add(new IHaveDamage(getInfoModel()));
		getThinkStates().add(new ImGoingToDie(getInfoModel()));
		getThinkStates().add(new ImStuck(getInfoModel()));
		getThinkStates().add(new ImNearGasStation(getInfoModel()));
	//	getThinkStates().add(new NearFire(getInfoModel()));
		getThinkStates().add(new NoCom(getInfoModel()));
		
//		getThinkStates().add(new LowCom(getInfoModel()));
//		getThinkStates().add(new RoadCivilians(getInfoModel()));
		getThinkStates().add(new SelfDecide(getInfoModel()));
	//	getThinkStates().add(new ExcessiveSearchState(getInfoModel()));
	//	getThinkStates().add(new NoCivilian(getInfoModel()));
		getThinkStates().add(new VIrtualRescueState(getInfoModel()));
		getThinkStates().add(new RescueState(getInfoModel()));
		getThinkStates().add(new SearchState(getInfoModel()));
		

		
		
	}

	public AmbulanceInformationModel getInfoModel() {
		return (AmbulanceInformationModel) infoModel;
	}
}