package sos.ambulance_v2.decision.controller;

import java.util.ArrayList;
import java.util.Comparator;

import rescuecore2.misc.Pair;
import sos.ambulance_v2.AmbulanceTeamAgent;
import sos.ambulance_v2.tools.MultiDitinctSourceCostInMM;
import sos.base.entities.AmbulanceTeam;
import sos.base.entities.Area;
import sos.base.entities.Human;
import sos.base.entities.Refuge;
import sos.base.util.SOSGeometryTools;

public class CiviliansAndMeasurments {
	public MultiDitinctSourceCostInMM costTable;
	AmbulanceTeamAgent ambulance;
	AmbulanceTeamAgent imaginedAmbulance;
	private ArrayList<Pair<AmbulanceTeam, Double>> toAmb;
	ArrayList<Pair<Refuge, Double>> toRef;
	ArrayList<AmbulanceTeam> ambAgents;
	ArrayList<Area> ambAreas;
	ArrayList<Refuge> refuges;
	private int numberOfAmbNeeded;
	private Human target;
	private ArrayList<Pair<AmbulanceTeam,Integer>> myAmbs = new ArrayList<Pair<AmbulanceTeam,Integer>>();

	public CiviliansAndMeasurments(Human choosedTarget,
			ArrayList<AmbulanceTeam> ambAgents, ArrayList<Refuge> refuges) {
		target = choosedTarget;
		this.ambAgents = ambAgents;
		this.refuges = refuges;
		toRef = new ArrayList<Pair<Refuge,Double>>();
	}

	public void toRefuge() {
		Double max = 0.0;
		toRef.clear();
		for (Refuge ref : refuges) {
			toRef.add(new Pair<Refuge, Double>(ref, SOSGeometryTools.distance(
					target.getAreaPosition(), ref.getAreaPosition())));
		}

		for (int i = 0; i < getToAmb().size(); i++) {
			if (toRef.get(i + 1).second() > toRef.get(i).second())
				max = toRef.get(i + 1).second();
			max = toRef.get(i).second();
		}

		for (int i = 0; i < toRef.size(); i++) {
			toRef.set(i, new Pair<Refuge, Double>(toRef.get(i).first(), (toRef
					.get(i).second() / max)));
		}

	}


	public int getNumberOfAmbNeeded() {
		return numberOfAmbNeeded;
	}
	

	public void setNumberOfAmbNeeded(int numberOfAmbNeeded) {
		this.numberOfAmbNeeded = numberOfAmbNeeded;
	}
	
	public void setTarget(){
		this.target = target;
	}
	
	public Human getTarget(){
		return target;
	}

	public ArrayList<Pair<AmbulanceTeam, Double>> getToAmb() {
		return toAmb;
	}

	public void setToAmb(ArrayList<Pair<AmbulanceTeam, Double>> toAmb) {
		this.toAmb = toAmb;
	}

	/**
	 * @return the myAmbs
	 */
	public ArrayList<Pair<AmbulanceTeam, Integer>> getMyAmbs() {
		return myAmbs;
	}

	/**
	 * @param myAmbs the myAmbs to set
	 */
	public void setMyAmbs(ArrayList<Pair<AmbulanceTeam, Integer>> myAmbs) {
		this.myAmbs = myAmbs;
	}

}

class AmbCostComparator implements Comparator<Pair<AmbulanceTeam, Double>> {

	@Override
	public int compare(Pair<AmbulanceTeam, Double> h1,
			Pair<AmbulanceTeam, Double> h2) {// Ambulance
		// cost
		if (h1.second() < h2.second())
			return -1;
		else if (h1.second() > h2.second())
			return 1;

		return 0;

	}
}