package sos.ambulance_v2.decision.states;

import java.util.List;

import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;
import sos.tools.decisionMaker.implementations.targets.EmptyTarget;
import sos.tools.decisionMaker.implementations.tasks.RestTask;

public class ImDead extends SOSIState<AmbulanceInformationModel> {

	public ImDead(AmbulanceInformationModel infoModel) {
		super(infoModel);
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {

		if (infoModel.getATEntity().getHP() != 0)
			return null;

		infoModel.getLog().info("^^ I'M DEAD State ^^");
		
		infoModel.getAmbulance().threelast_task = infoModel.getAmbulance().twolast_task;
		infoModel.getAmbulance().twolast_task = infoModel.getAmbulance().last_task;
		infoModel.getAmbulance().last_task = ATTask.RestTask;
		
		infoModel.getATEntity().getWork().setMyState(ATTask.RestTask);
		
		return new RestTask(new EmptyTarget(), infoModel.getTime(), "Ambulance Agent is dead");

	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data,
			SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isvalid() {
		if (infoModel.getATEntity().getHP() == 0)
			return false;
		return true;

	}

}
