package sos.ambulance_v2.decision.states;

import java.util.List;
import java.util.PriorityQueue;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.decision.AmbUtile;
import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.Area;
import sos.base.entities.Human;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;
import sos.tools.decisionMaker.implementations.targets.AreaTarget;
import sos.tools.decisionMaker.implementations.tasks.GoToRefugeTask;
import sos.tools.decisionMaker.implementations.tasks.StandardMoveToAreaTask;

public class ImGoingToDie extends SOSIState<AmbulanceInformationModel> {

	// TODO DO we really need this state? 
	
	Pair<? extends Area, Point2D> place;
	PriorityQueue<Pair<Human, Integer>> ListOfHumans;
	int TimeToRefuge;
	int ATDeathTime;
	
	
	public ImGoingToDie(AmbulanceInformationModel infoModel) {
		super(infoModel);
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		
		ATDeathTime = SimpleDeathTime.getEasyLifeTime(infoModel.getATEntity().getHP(), infoModel.getATEntity().getDamage(), infoModel.getTime());
	
		// TODO Is "10" ok?
		
		if( ATDeathTime - infoModel.getTime() > 10)
			return null;
		
		
		infoModel.getLog().info("^^ GOING TO DIE State ^^");
		
		ListOfHumans = new PriorityQueue<Pair<Human, Integer>>();
		
		if(infoModel.getModel().refuges().size() != 0)
			TimeToRefuge = infoModel.getATEntity().getRescueInfo().getTimeToRefuge();
		else 
			TimeToRefuge = 0;
		
		if( ATDeathTime > TimeToRefuge + 2 && ATDeathTime < TimeToRefuge + 6)
			return new GoToRefugeTask(null, infoModel.getTime());
		
		
		// TODO If there is any visible Human, just rescue that, don't search for nearest.  
		
		
		Human nearestTarget = AmbUtile.humansAndTimes(infoModel).get(0).first();
		
		infoModel.getATEntity().getWork().setTarget(nearestTarget, this);
		infoModel.getAmbulance().last_task = ATTask.MoveTask;		
		
		place = nearestTarget.getPositionPair();
		
		int busy = AmbUtile.getMyBusyCycles(nearestTarget, place, ATTask.MoveTask, infoModel.getAmbulance());
		AmbUtile.sendInfoMsgIfRequire(0, busy, infoModel.getAmbulance());
		AmbUtile.sendStatueMsgBySay(0, false, infoModel.getAmbulance(), infoModel.getAmbulance().last_task);
		AmbUtile.sendMessage(0, infoModel.getAmbulance(), nearestTarget);
		return new StandardMoveToAreaTask(new AreaTarget(nearestTarget.getAreaPosition()) , infoModel.getTime());
		
	}

	
	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void hear(String header, DataArrayList data,
			SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public void findNearestTarget(){

		ListOfHumans.clear();
		
		for(Pair<Human, Integer> list : ListOfHumans){
			int DeathTime = SimpleDeathTime.getEasyLifeTime(list.first().getHP(), list.first().getDamage(), infoModel.getTime());
			if((list.first().getDamage() != 0 || list.first().getBuriedness() != 0) &&  DeathTime - infoModel.getTime() < 50 )
			{
				///////////////////////////////////check what to adddddddd\\\\\\\\\\\\\\\\\\\\\\\\\\\
				ListOfHumans.add(new Pair<Human,Integer>(list.first(),list.second()));
			}
		}

	}
	
	

}
