package sos.ambulance_v2.decision.states;

import java.util.ArrayList;
import java.util.List;

import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.base.RescueInfo.IgnoreReason;
import sos.base.entities.Civilian;
import sos.base.entities.GasStation;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;
import sos.tools.decisionMaker.implementations.targets.AreaTarget;
import sos.tools.decisionMaker.implementations.tasks.StandardMoveToAreaTask;

public class ImNearGasStation extends SOSIState<AmbulanceInformationModel>{

	List<Road> Roads;
	public ImNearGasStation(AmbulanceInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		ArrayList<Civilian> mycivs;
	
		
		
		
		
		
		
		
		
		
		infoModel.getLog().info("//ImNearGasStation State\\");
		for ( GasStation gasStation : infoModel.getModel().GasStations()){
			
			
			
			
			
			
			if(SOSGeometryTools.distance(gasStation, infoModel.getAmbulance().location()) < 5000 && gasStation.getTemperature() > 35 && (gasStation.getFieryness() == 0 || gasStation.getFieryness() == 4)){
				
				Roads = infoModel.getModel().roads();
				if(infoModel.getATEntity().getWork().getTarget() != null)
					infoModel.getATEntity().getWork().getTarget().getRescueInfo().setIgnoredUntil(IgnoreReason.Unreachable, infoModel.getTime() + 5);
			for (Road Road : Roads )
				if(SOSGeometryTools.distance(Road.getAreaPosition(), gasStation.getAreaPosition()) > 5500){
					infoModel.getAmbulance().threelast_task = infoModel.getAmbulance().twolast_task;
					infoModel.getAmbulance().twolast_task = infoModel.getAmbulance().last_task;
					infoModel.getAmbulance().last_task = ATTask.GoToRoad;
					infoModel.getAmbulance().last_task = ATTask.MoveTask;
					return new StandardMoveToAreaTask(new AreaTarget(Road.getAreaPosition()), infoModel.getTime());
				}
			}
	}
		return null;
		
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void hear(String header, DataArrayList data,
			SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
