package sos.ambulance_v2.decision.states;

import java.util.ArrayList;
import java.util.List;

import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.decision.AmbUtile;
import sos.base.entities.AmbulanceTeam;
import sos.base.entities.Human;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class NoCivilian extends SOSIState<AmbulanceInformationModel> {

	
	AmbulanceTeam agent;
	Human humans;
	Human target;
	
	ArrayList<Human> civilians;

	
	double minDis;
	double moveDistance;
	
	
	public NoCivilian(AmbulanceInformationModel infoModel) {
		super(infoModel);
	
		civilians = new ArrayList<Human>();
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		agent = infoModel.getATEntity();
	
		if (infoModel.getTime() < 10)
			return null;
					
		if (AmbUtile.isValiadToDecide(agent.getWork().getTarget(), infoModel.getTime(), false, agent))
			return null;
		
		infoModel.getLog().info("^^ NOCIVILIAN State ^^");
		
		addCivilians();
		setCost();
		
		if(AmbUtile.isValiadToDecide(target, infoModel.getTime(), false, agent)){
			agent.getWork().setTarget(target, this);
			infoModel.getAmbulance().setUnderMissionTarget(target);
			infoModel.getLog().info("** No good choice, deciding based on Dis" + target.getID() + "**");
			infoModel.getAmbulance().target = target;
		}
		else
			infoModel.getLog().info("**No any good choice. Moving to Search State **");
		
		return null;
	}


	private void addCivilians() {
		civilians.clear();

		for(Human human : infoModel.getModel().humans())
			if (AmbUtile.isValiadToDecide(human, infoModel.getTime(), false, agent))
				civilians.add(human);
		
	}
	
	private void setCost() {
		minDis = Double.MAX_VALUE;
		
		for (Human h : civilians)
		{
			moveDistance = infoModel.getModel().getDistance(agent.getPositionArea(), h.getPositionArea());
			if(minDis > moveDistance){
				minDis = moveDistance;
				target = h;
			}
		}
		
			
			
		
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
