package sos.ambulance_v2.decision.states;

import java.awt.Shape;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.misc.Pair;
import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.decision.AmbUtile;
import sos.ambulance_v2.tools.GraphUsage;
import sos.base.entities.Area;
import sos.base.entities.Civilian;
import sos.base.entities.Human;
import sos.base.entities.Refuge;
import sos.base.entities.StandardEntity;
import sos.base.entities.VirtualCivilian;
import sos.base.message.structure.MessageConstants.Type;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.search_v2.tools.cluster.ClusterData;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

/**
 * @author ma:))
 */

public class NoCom extends SOSIState<AmbulanceInformationModel> {
	public GraphUsage gu;

	boolean rescuedCivsChecked = true;
	public ArrayList<Civilian> healthcivs2 = new ArrayList<Civilian>();
	public ArrayList<Civilian> buridycivs = new ArrayList<Civilian>();
	public ArrayList<Human> civilians;
	public ArrayList<Civilian> mycivs = new ArrayList<Civilian>();
	ArrayList<VirtualCivilian> virtCivilians = new ArrayList<VirtualCivilian>();
	ArrayList<Pair<VirtualCivilian, Float>> VirtualCosts = new ArrayList<Pair<VirtualCivilian, Float>>();
	ArrayList<Pair<Human, Float>> CivilianCosts = new ArrayList<Pair<Human, Float>>();
	ArrayList<Human> ALL;
	ArrayList<Pair<Civilian, Integer>> civilCosts = new ArrayList<Pair<Civilian, Integer>>();
	int numHealthyCivs;
	int moveTime;
	int moveTime2;
	int Rescuedcivs;
	float BestCivilianCost;
	float BestVirtualCost;
	float targetcost;
	float targetcost2;
	double moveDistance;
	double min2 = 100000000;
	double moveDistance2;
	VirtualCivilian virciv;
	Human civi;
	Human bestCivilian;
	VirtualCivilian bestVirtual;
	ClusterData closeclus;
	Shape MyCluster;
	ClusterData myCluster;

	Pair<VirtualCivilian, Float> bestVirtCiv = null;
	Pair<Human, Float> BestCivilians = null;

	public NoCom(AmbulanceInformationModel infoModel) {
		super(infoModel);
		gu = new GraphUsage(infoModel.getAgent());

	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		if (myCluster == null)
			myCluster = infoModel.getModel().searchWorldModel.getClusterData();
		if (MyCluster == null)
			MyCluster = infoModel.getModel().searchWorldModel.getClusterData().getConvexShape();
		if (!(infoModel.getAgent().messageSystem.type == Type.LowComunication) && !(infoModel.getAgent().messageSystem.type == Type.NoComunication) && !(infoModel.getAgent().messageSystem.type == Type.WithMiddleMan) && !(infoModel.getAgent().messageSystem.type == Type.CenteralMiddleMan) && !(infoModel.getAgent().messageSystem.type == Type.NoMiddleMan))
			return null;
		if (infoModel.getTime() < 3)
			return null;
		if ((infoModel.getAmbulance().virtualTarget != null && (!infoModel.getAmbulance().virtualTarget.isIgnored() && infoModel.getAmbulance().virtualTarget.isPositionDefined() || infoModel.getAmbulance().virtualTarget.getDeathTime() > infoModel.getTime() + 6))
				|| (infoModel.getAmbulance().target != null && infoModel.getAmbulance().target.getHP() != 0 && !(infoModel.getAmbulance().target.getAreaPosition() instanceof Refuge && !(infoModel.getATEntity().getAreaPosition() instanceof Refuge))))
			return null;

		if ((infoModel.getModel().civilians().size() == 0) && infoModel.getTime() < 6)
			return null;

		for (Civilian civ : infoModel.getModel().civilians()) {
			if (MyCluster.contains(civ.getX(), civ.getY())) {
				mycivs.add(civ);
			}
		}

		for (Civilian buridcivs : mycivs) {
			if (buridcivs.getBuriedness() != 0) {
				buridycivs.add(buridcivs);
			}
		}

		for (Civilian healthycivs2 : mycivs) {
			if (healthycivs2.getBuriedness() == 0) {
				healthcivs2.add(healthycivs2);
			}
		}

		Rescuedcivs = healthcivs2.size() - rescuedCivs();

		if (7 * buridycivs.size() / 10 >= Rescuedcivs) {

			ClosestCluster();
			infoModel.getLog().log(" my cluster is checked");
			//TODO move chie
			//	infoModel.getATEntity().getWork().setMyState(ATTask.MoveTask);

		}
		else {

			infoModel.getLog().logln("^^ In LOW COM/No Come State ^^");

			infoModel.getLog().logln("^^qable set civil ^^");
			setCivilian(myCluster);
			Pair<Human, Float> bst = getBestCiv();
			Pair<VirtualCivilian, Float> bstVirt = getBestVirtCiv();
			infoModel.getAmbulance().target = bst.first();
			infoModel.getATEntity().getWork().setRealTarget(bst.first());
			infoModel.getATEntity().getWork().setMyState(ATTask.RescueTask);
			if (bst != null && infoModel.getAmbulance().target != null)
				infoModel.getLog().log("Target" + infoModel.getAmbulance().target.getID() + " bst : " + bst);
			setVirtual(myCluster);
			infoModel.getAmbulance().virtualTarget = bstVirt.first();
			infoModel.getATEntity().getWork().setVirtualTarget(bstVirt.first());

			bestCivilian = getBestCiv().first();
			infoModel.getLog().info("best civ cost= " + getBestCiv().second());

			BestCivilianCost = bst.second();

			if (bestCivilian != null)
				infoModel.getLog().info("** Decide : My best civ is: " + bestCivilian.getID() + "with cost" + BestCivilianCost);

			bestVirtual = getBestVirtCiv().first();
			if (bstVirt != null)
				infoModel.getLog().info("best virtual cost= " + bstVirt.second());
			BestVirtualCost = getBestVirtCiv().second();

			if (bestVirtual != null)
				infoModel.getLog().info("** Decide : My best virtual civ is: " + BestVirtualCost + "with cost" + BestVirtualCost);

			compare(bestCivilian, bestVirtual, BestCivilianCost, BestVirtualCost);

			infoModel.getLog().info("^^Done LOW COM State^^");

		}
		return null;
	}

	public void setVirtual(ClusterData myCluster) {
		infoModel.getLog().info("setvir tabe" + infoModel.getModel().getVirtualCivilians().size());

		for (VirtualCivilian civil : infoModel.getModel().getVirtualCivilians()) {
			infoModel.getLog().info("tu fore1");
			if (!AmbUtile.isValiadVirtualToDecide(civil, infoModel.getTime(), infoModel.getATEntity()))
				continue;

			infoModel.getLog().info("** setVirtual : adding virt : " + civil + "**");
			virtCivilians.add(civil);
		}

		for (VirtualCivilian virtual : virtCivilians) {
			moveTime = gu.getFoolMoveTimeFromTo(infoModel.getATEntity().getAreaPosition(), virtual.getPosition());
			if (!myCluster.getBuildings().contains(virtual.getPosition())) {
				infoModel.getLog().info("**My cluster is not done**");
				continue;
			}
			virciv = virtual;
			targetcost = ((20 + (moveTime)) * virtual.getDeathTime() + 1) / ((virtual.getBuridness() * 17) + 1);
			infoModel.getLog().info(targetcost + "!!" + moveTime + "!!" + virtual.getDeathTime() + "!!" + virtual.getBuridness());

			VirtualCosts.add(new Pair<VirtualCivilian, Float>(virciv, targetcost));
		}
	}

	private Pair<VirtualCivilian, Float> getBestVirtCiv() {
		infoModel.getLog().info("getting best virt function");
		float min = Integer.MAX_VALUE;

		for (Pair<VirtualCivilian, Float> civ : VirtualCosts) {
			//			infoModel.getLog().info("in for" + civ.second());
			if (civ.second() < min) {
				min = civ.second();
				bestVirtCiv = new Pair<VirtualCivilian, Float>(civ.first(), min);
				infoModel.getLog().log("BestVirCost =" + bestVirtCiv.second());
			}
		}

		return bestVirtCiv;

	}

	public void setCivilian(ClusterData myCluster) {
		infoModel.getLog().info("set civilian");
		ALL = new ArrayList<Human>();

		ALL.addAll(infoModel.getModel().civilians());
		infoModel.getLog().info("all=" + ALL.size());
		if (infoModel.getTime() < 90 || (infoModel.getModel().getLastAfterShockTime() > 1 && infoModel.getTime() < 210)) {
			infoModel.getLog().info("**setCivilian : adding agents to the list**");
			ALL.addAll(infoModel.getModel().agents());
		}

		civilians=new ArrayList<Human>();
		for (Human civ : ALL) {
			infoModel.getLog().info("fore all");
			if (!(AmbUtile.isValiadToDecide(civ, infoModel.getTime(), false, infoModel.getATEntity())))
				continue;

			//TODO getbuiried...
			if (civ.getHP() < 2000 && civ.getBuriedness() > 20 && civ.getDamage() < 50)
				continue;
		//	infoModel.getLog().warn("hiiiiii");

			if (civ.getRescueInfo().getDeathTime() > 330)
				continue;
		//	infoModel.getLog().warn("hiiiiii22222");
			//
			//			if (!(myCluster.getClusterArea().contains(civ.getX(), civ.getY()))){
			//			infoModel.getLog().info("jjjjjj");
			//				continue;
			//			}

			infoModel.getLog().warn("** setCivilian : adding valid civilian :" + civ.getID());
			civilians.add(civ);
		}

		removeOtherClusterTargets();
	//	infoModel.getLog().warn("SIZE= "+ civilians.size());

		for (Human civil : civilians) {
			//TODO
			infoModel.getLog().info("*fore civilians*");
			moveTime2 = gu.getFoolMoveTimeFromTo(infoModel.getATEntity().getAreaPosition(), (Area) civil.getPosition());

			civi = civil;
			targetcost2 = (((20 + (moveTime)) * civil.getRescueInfo().getDeathTime()) + 1) / ((civil.getBuriedness() * (civil.getHP())) + 1);

			CivilianCosts.add(new Pair<Human, Float>(civi, targetcost2));
			infoModel.getLog().log("CivilianCosts" + CivilianCosts);
		}
	}

	public void removeOtherClusterTargets() {

		ArrayList<ClusterData> validClusters = new ArrayList<ClusterData>();

		final ClusterData myCluster = infoModel.getModel().searchWorldModel.getClusterData();

		ArrayList<ClusterData> clusters = new ArrayList<ClusterData>(infoModel.getModel().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new DistanceComparator(infoModel.getAgent()));

		validClusters.add(myCluster);

		if (!clusters.isEmpty()) {
			validClusters.add(clusters.get(0));
		}

		ArrayList<Human> newTargets = new ArrayList<Human>();
		for (Human target : civilians) {
			if ((SOSGeometryTools.distance(target.getAreaPosition().getPositionPoint(), infoModel.getAmbulance().me().getPositionPoint())) < (infoModel.getModel().getBounds().getWidth() / 8)) {
				newTargets.add(target);
				continue;
			}
			for (ClusterData validCluster : validClusters) {
				if (validCluster.getBuildings().contains(target.getAreaPosition()))
					newTargets.add(target);
			}
		}

		civilians = newTargets;
	}

	private Pair<Human, Float> getBestCiv() {
		infoModel.getLog().info("getting best civ function");
		float min = Float.MAX_VALUE;

		for (Pair<Human, Float> civ : CivilianCosts) {
			infoModel.getLog().log("CivilCost.SIZE" + civilCosts.size());
			if (civ.second() < min) {
				min = civ.second();
				BestCivilians = civ;
				infoModel.getLog().log("BestCivs=" + BestCivilians.second());
			}
		}

		return BestCivilians;

	}

	private void compare(Human bestCivilian, VirtualCivilian bestVirtual, float BestCivilianCost, float BestVirtualCost) {

		// Comparing Virtual and Civilian

		infoModel.getLog().info("** Compare: **");
		if ((bestCivilian == null || BestCivilianCost * 10000 == 0) && (bestVirtual == null || BestVirtualCost * 10000 == 0)) {

			infoModel.getAmbulance().target = null;
			infoModel.getATEntity().getWork().setRealTarget(null);
			infoModel.getAmbulance().virtualTarget = null;
			infoModel.getATEntity().getWork().setVirtualTarget(null);

			return;
		}

		if (bestVirtual == null || BestVirtualCost == 0) {

			infoModel.getLog().info("** Compare : Don't have a virt target, my real target is:" + getBestCiv().first().getID() + "**");
			infoModel.getAmbulance().target = bestCivilian;
			infoModel.getATEntity().getWork().setTarget(bestCivilian, this);

			return;
		}

		else if (getBestCiv().first() == null || getBestCiv().second() == null) {

			infoModel.getLog().info("** Compare : Don't have a target, my virt target is:" + bestVirtual + "**");
			infoModel.getAmbulance().virtualTarget = bestVirtual;
			infoModel.getATEntity().getWork().setTarget(null, null);
			infoModel.getATEntity().getWork().setVirtualTarget(bestVirtual);

			return;

		}

		//baraks
		else if ((BestVirtualCost < BestCivilianCost) || (BestVirtualCost == BestCivilianCost)) {

			infoModel.getLog().info("** Compare : I have a target that is :" + bestCivilian + "**");

			infoModel.getAmbulance().target = bestCivilian;
			infoModel.getATEntity().getWork().setTarget(bestCivilian, this);

			infoModel.getAmbulance().virtualTarget = null;
			infoModel.getATEntity().getWork().setVirtualTarget(null);

			return;
		}

		else
		{
			infoModel.getLog().info("** Compare : I have a virtual target that is :" + bestVirtual + "**");

			infoModel.getAmbulance().target = null;
			infoModel.getATEntity().getWork().setRealTarget(null);

			infoModel.getAmbulance().virtualTarget = bestVirtual;
			infoModel.getATEntity().getWork().setVirtualTarget(bestVirtual);

			return;
		}

	}

	private int rescuedCivs() {
		if (rescuedCivsChecked) {
			for (Civilian healthycivs2 : mycivs) {
				if (healthycivs2.getBuriedness() == 0) {
					healthcivs2.add(healthycivs2);
				}
			}
			numHealthyCivs = healthcivs2.size();
			rescuedCivsChecked = false;
		}
		return numHealthyCivs;

	}

	public ClusterData ClosestCluster() {
		for (ClusterData clus : infoModel.getSearch().getSearchWorld().getAllClusters()) {

			moveDistance2 = SOSGeometryTools.distance(infoModel.getATEntity().getPositionArea(), clus.getNearestBuildingToCenter());
			if (min2 > moveDistance) {
				min2 = moveDistance2;
				infoModel.getMyCluster().equals(clus);
				closeclus = clus;

			}

		}

		return closeclus;
	}

	//TODO

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}
}

//class CostComparator implements Comparator<Pair<Human, Integer>> {
//	@Override
//	public int compare(Pair<Human, Integer> h1, Pair<Human, Integer> h2) {// Target
//																		  // cost
//
//		if (h1.second() < h2.second())
//			return -1;
//		else if (h1.second() > h2.second())
//			return 1;
//		else if (h1.second() == h2.second() && (h1.first().getID().getValue() > h2.first().getID().getValue()))
//			return -1;
//		else
//			return 1;
//
//	}
//}
