package sos.ambulance_v2.decision.states;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import sos.ambulance_v2.AmbulanceInformationModel;
import sos.base.entities.Human;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;
import be.abeel.util.Pair;

public class RoadCivilians extends SOSIState<AmbulanceInformationModel> {

	public RoadCivilians(AmbulanceInformationModel infoModel) {
		super(infoModel);
	}

	ArrayList<Pair<Human, Integer>> roadCivilians;

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {

		if (infoModel.getAmbulance().underMissionTarget() != null || infoModel.getAmbulance().isLoadingInjured())
			return null;
		infoModel.getLog().info("^^ In road civilians^^");
		roadCivilians = new ArrayList<Pair<Human, Integer>>();
		findRoadCivilians();
		if (roadCivilians.size() != 0) {
			infoModel.getAmbulance().target = roadCivilians.get(0).x();
			infoModel.getATEntity().getWork().setTarget(roadCivilians.get(0).x(), this);
			infoModel.getAmbulance().setUnderMissionTarget(null);
		}
		return null;
	}

	private void findRoadCivilians() {
		int moveDistance;
		for (Human h : infoModel.getModel().humans())
			if (h.getAreaPosition() instanceof Road && h.isBuriednessDefined() && h.getBuriedness() != 0)
			{
				moveDistance = infoModel.getModel().getDistance(infoModel.getATEntity().getPositionArea(), h.getAreaPosition());
				roadCivilians.add(new Pair<Human, Integer>(h, moveDistance));
			}

		Collections.sort(roadCivilians, new humanComparator());
		// TODO Auto-generated method stub

	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data,
			SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isvalid() {
		if (infoModel.getATEntity().getHP() == 0)
			return false;
		return true;

	}

}

class humanComparator implements Comparator<Pair<Human, Integer>> {
	@Override
	public int compare(Pair<Human, Integer> hm1, Pair<Human, Integer> hm2) {
		if (hm1.y() < hm2.y())
			return -1;
		if (hm1.y() > hm2.y())
			return 1;
		return 0;
	}

}
