package sos.ambulance_v2.decision.states;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.decision.AmbUtile;
import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.Human;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.search_v2.tools.cluster.ClusterData;
import sos.tools.decisionMaker.definitions.commands.SOSITarget;
import sos.tools.decisionMaker.definitions.commands.SOSTask;

public class SainaSearchTask extends SOSTask<SOSITarget> {

	AmbulanceInformationModel infoModel;
	ArrayList<Building> MyClusterBuildings;
	ArrayList<Building> NeighbourClustersBuildings = new ArrayList<Building>();

	public SainaSearchTask(SOSITarget target, int creatinTime, AmbulanceInformationModel f) {
		super(target, creatinTime);
		infoModel = f;
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSITarget getTarget() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void execute(SOSAgent<? extends Human> agent) throws SOSActionException {
		isAllChecked();
		if (infoModel.getAmbulance().last_task == ATTask.SearchTask) {
			infoModel.getLog().info("SabaSearchTask: Last task was sabaSearch. ^_^");
			if (infoModel.getAmbulance().searchBuildingTarget != null) {
				infoModel.getLog().info("SabaSearchTask: Has a target ^_^");
				if ((SOSGeometryTools.distance(infoModel.getAmbulance().me().getAreaPosition(), infoModel.getAmbulance().searchBuildingTarget) <
						100  &&
						infoModel.getAmbulance().getVisibleEntities(Building.class).contains(infoModel.getAmbulance().searchBuildingTarget))
						|| checkReachability()) {
					infoModel.getLog().info("SabaSearchTask: Distance was close so it's considered being search. ^_^");
					infoModel.getAmbulance().searchBuildingTarget.setChecked(true);
					infoModel.getAmbulance().searchBuildingTarget = null;
				}
				else if(road != null){
					infoModel.getLog().info("SabaSearchTask: Distance was'nt close so it's going there. :/ ");
					infoModel.getAmbulance().move.move(road, StandardMove.class);
				}
				else {
					infoModel.getLog().info("SabaSearchTask: Distance was'nt close so it's going there. :/ ");
					infoModel.getAmbulance().move.moveToShape(infoModel.getAmbulance().searchBuildingTarget.getSearchAreas(), StandardMove.class);
				}
					
			}
		}

		Building last = null;
		int counter = 0;
		int myP = infoModel.getAmbulance().myPlaceInGroup();
		for (Building b : infoModel.getMyCluster().getBuildings()) {
			last = b;
			if (b.getChecked()) {
				infoModel.getLog().info("SabaSearhTask: Building id " + b.getID() + " in its own cluster, checked was false. ");
				continue;
			}
			if (myP != -1 && counter < myP) {
				counter++;
				continue;
			}

			infoModel.getAmbulance().searchBuildingTarget = b;
			infoModel.getAmbulance().move.moveToShape(b.getSearchAreas(), StandardMove.class);
		}

		ArrayList<ClusterData> clusters = new ArrayList<ClusterData>();
		clusters.addAll(infoModel.getModel().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new DistanceComparator(infoModel.getAgent()));

		NeighbourClustersBuildings.addAll(clusters.get(0).getBuildings());
		NeighbourClustersBuildings.addAll(clusters.get(1).getBuildings());
		NeighbourClustersBuildings.addAll(clusters.get(2).getBuildings());
		NeighbourClustersBuildings.addAll(clusters.get(3).getBuildings());
		NeighbourClustersBuildings.addAll(clusters.get(4).getBuildings());
		infoModel.getLog().info("SabaSearchTask: Neighbour clusters builidings are: " + NeighbourClustersBuildings);
		Collections.sort(NeighbourClustersBuildings, new BuildingDistanceComparator(infoModel.getAgent()));

		counter = 0;
		myP = infoModel.getAmbulance().myPlaceInGroup();
		for (Building b : NeighbourClustersBuildings) {

			if (b == null)
				continue;
			if (b.getChecked()) {
				infoModel.getLog().info("SabaSearchTask: Builidng id= " + b.getID() + "in neighbour clusters buildings was checked so continue. ");
				continue;
			}

			if (myP != -1 && counter < myP) {
				counter++;
				last = b;
				continue;
			}
			infoModel.getAmbulance().searchBuildingTarget = b;
			infoModel.getLog().info("SabaSearchTask: Builidng id= " + b.getID() + "in neighbour clusters buildings wasn't checked so moving to this building. ");
			infoModel.getAmbulance().move.moveToShape(b.getSearchAreas(), StandardMove.class);

		}

		infoModel.getLog().info("SabaSearchTask: Builidng id= " + last.getID() +
				"in neighbour clusters buildings wasn't checked so moving to this building. (There's not enough buildings to search. )");
		infoModel.getAmbulance().move.moveToShape(last.getSearchAreas(), StandardMove.class);

	}
	
	Road road = null;
	private boolean checkReachability() {

		Building target = infoModel.getAmbulance().searchBuildingTarget;

		if (AmbUtile.isReallyReachableBuilding(target, true))
			return false;
		for (sos.base.entities.Area n : target.getNeighbours())
			if (n instanceof Road && n.isReallyReachable(true)) {
				road = (Road) n;
				break;
			}
		
		if( road== null)
			return true;
		else if (infoModel.getEntity().getAreaPosition().getID().getValue() == road.getID().getValue())
			return true;

		return false;
	}

	public void isAllChecked() {

		for (Building b : NeighbourClustersBuildings) {
			if (b == null)
				continue;
			if (b.getChecked())
				continue;

			return;
		}

		makeFalse();
	}

	public void makeFalse() {

		for (Building b : NeighbourClustersBuildings)
			b.setChecked(false);
	}

}

class DistanceComparator implements Comparator<ClusterData> {

	private SOSAgent<? extends StandardEntity> agent = null;
	public DistanceComparator( SOSAgent<? extends StandardEntity> agent){
		this.agent=agent;
	}
	@Override
	public int compare(ClusterData o1, ClusterData o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(),agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
	
}

class BuildingDistanceComparator implements Comparator<Building> {

	private SOSAgent<? extends StandardEntity> agent = null;
	public BuildingDistanceComparator( SOSAgent<? extends StandardEntity> agent){
		this.agent=agent;
	}
	@Override
	public int compare(Building o1, Building o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(),agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}
