package sos.ambulance_v2.decision.states;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

import sos.ambulance_v2.ATTask;
import sos.ambulance_v2.AmbulanceInformationModel;
import sos.ambulance_v2.decision.AmbUtile;
import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.Human;
import sos.base.entities.StandardEntity;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.base.util.geom.ShapeInArea;
import sos.search_v2.tools.cluster.ClusterData;
import sos.tools.decisionMaker.definitions.commands.SOSITarget;
import sos.tools.decisionMaker.definitions.commands.SOSTask;

public class SearchTask extends SOSTask<SOSITarget> {

	AmbulanceInformationModel infoModel;
	ArrayList<Building> NeighbourClustersBuildings = new ArrayList<Building>();
	ArrayList<ClusterData> clusters = new ArrayList<ClusterData>();

	public SearchTask(SOSITarget target, int creatinTime, AmbulanceInformationModel info) {
		super(target, creatinTime);
		infoModel = info;
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSITarget getTarget() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void execute(SOSAgent<? extends Human> agent) throws SOSActionException {
		//isAllChecked();
		if (infoModel.getModel().getLastAfterShockTime() > 1)
			makeFalse();
		
		if (infoModel.getAmbulance().last_task == ATTask.SearchTask) {
			infoModel.getLog().info("SearchTask: Last task was Search");
			if (infoModel.getAmbulance().searchBuildingTarget != null) {
				infoModel.getLog().info("has a target");

				if (infoModel.getAmbulance().getVisibleEntities(Building.class).contains(infoModel.getAmbulance().searchBuildingTarget))
				{
					infoModel.getLog().info("visible entities contain");
					infoModel.getAmbulance().searchBuildingTarget.setChecked(true);
					infoModel.getAmbulance().searchBuildingTarget = null;
				}
				else {
					infoModel.getLog().info("did not contain");
					infoModel.getAmbulance().last_task = ATTask.SearchTask;
					infoModel.getAmbulance().move.moveToShape(infoModel.getAmbulance().searchBuildingTarget.getSearchAreas(), StandardMove.class);
				}
			}
		}

		Building last = null;
		int counter = 0;
		int myP = infoModel.getAmbulance().myPlaceInGroup();
		for (Building b : infoModel.getMyCluster().getBuildings()) {
			last = b;
			if (b.getChecked()) {
				infoModel.getLog().info("SearhTask: Building id " + b.getID() + " in its own cluster, checked was false. ");
				continue;
			}

			if (!isValid(b))
				continue;

			if (myP != -1 && counter < myP) {
				counter++;
				continue;
			}

			infoModel.getAmbulance().searchBuildingTarget = b;
			infoModel.getLog().info("ambulance is moving to shape");
			infoModel.getAmbulance().last_task = ATTask.SearchTask;
			infoModel.getAmbulance().move.moveToShape(b.getSearchAreas(), StandardMove.class);
		}
		clusters.addAll(infoModel.getAmbulance().model().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new SainaDistanceComparator(infoModel.getAgent()));

		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(0).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(1).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(2).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(3).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(4).getBuildings());
		infoModel.getLog().info("Neighbour clusters builidings are: " + NeighbourClustersBuildings);
		Collections.sort(NeighbourClustersBuildings, new BuildingDistanceComparator(infoModel.getAgent()));

		counter = 0;
		myP = infoModel.getAmbulance().myPlaceInGroup();
		for (Building b : NeighbourClustersBuildings) {

			if (b == null) {
				infoModel.getLog().info("b was null");
				continue;
			}

			if (b.getChecked()) {
				infoModel.getLog().info(" Builidng id= " + b.getID() + "in neighbour clusters buildings was checked so continue. ");
				continue;
			}
			if ((b.getFieryness() > 0 && b.getFieryness() < 4) || b.getFieryness() == 8) {
				b.setChecked(true);
				continue;
			}
			if (myP != -1 && counter < myP) {
				counter++;
				last = b;
				continue;
			}
			infoModel.getAmbulance().searchBuildingTarget = b;
			infoModel.getLog().info("Builidng id= " + b.getID() + "in neighbour clusters buildings wasn't checked so moving to this building. ");
			infoModel.getAmbulance().last_task = ATTask.SearchTask;
			infoModel.getAmbulance().move.moveToShape(b.getSearchAreas(), StandardMove.class);

		}

		infoModel.getLog().info("Builidng id= " + last.getID() +
				"in neighbour clusters buildings wasn't checked so moving to this building. (There's not enough buildings to search. ");
		infoModel.getAmbulance().last_task = ATTask.SearchTask;
		infoModel.getAmbulance().move.moveToShape(last.getSearchAreas(), StandardMove.class);

	}

	private boolean isValid(Building b) {
		for (ShapeInArea sia : b.getSearchAreas())
			if (AmbUtile.isReallyReachableBuilding(sia.getArea(), true))
				return true;
		return false;
	}

	public void isAllChecked() {
		infoModel.getLog().info("in isAllCHecked function");

		for (Building b : infoModel.getMyCluster().getBuildings()) {
			if (b == null) {
				infoModel.getLog().info("bb was null");
				continue;
			}
			if (b.getChecked()) {
				infoModel.getLog().info("b was checked true" + b.getID());
				continue;
			}
			return;
		}

		makeFalse();
	}

	public void makeFalse() {
		infoModel.getLog().info("in makeFalse function");
		for (Building b : infoModel.getMyCluster().getBuildings()) {
			infoModel.getLog().info("b is being setchecked with false" + b.getID());
			b.setChecked(false);
		}
	}

	public ClusterData getArgumentSortedCluster(int i) {

		if (clusters.get(i) != null)
			return clusters.get(i);

		return null;

	}

}

class SainaDistanceComparator implements Comparator<ClusterData> {

	private SOSAgent<? extends StandardEntity> agent = null;

	public SainaDistanceComparator(SOSAgent<? extends StandardEntity> agent) {
		this.agent = agent;
	}

	@Override
	public int compare(ClusterData o1, ClusterData o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}
