package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Vector;

import sos.ambulance_v2.tools.GraphUsage;
import sos.base.entities.Building;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.fire_v2.decision.FireInformationModel;
import sos.search_v2.tools.cluster.ClusterData;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

//DONE
public class Extinguish extends SOSIState<FireInformationModel> {
	public GraphUsage gu;
	public ClusterData findBuildingCluster;

	public Extinguish(FireInformationModel infoModel) {

		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	//////MAHSHID///////
	public boolean GoToMyCluster() {

		gu = new GraphUsage(infoModel.getAgent());
		ArrayList<Building> Buildings = new ArrayList<Building>();
		ArrayList<Building> myClusterBuildings = new ArrayList<Building>();
		myClusterBuildings.addAll(infoModel.getModel().searchWorldModel.getClusterData().getBuildings());
		ArrayList<Building> fireBuildinginMyCluster = new ArrayList<Building>();
		for (Building b : myClusterBuildings) {
			if (b.getFieryness() > 0 && b.getFieryness() < 4) {
				fireBuildinginMyCluster.add(b);
			}
		}

		infoModel.self().sorted.weight.setWeights(fireBuildinginMyCluster);

//		float avgMC = 0;
//		for (Building b : fireBuildinginMyCluster) {
//			avgMC += b.getWeight();
//		}
//		avgMC = avgMC / Math.max(1, fireBuildinginMyCluster.size());
//		float avg = 0;
//		for (Building b : infoModel.self().MyZone.FireZoneBuildings) {
//			avg += b.getWeight();
//		}
//		avg = avg / Math.max(1, infoModel.self().MyZone.FireZoneBuildings.size());
//		if (avgMC > avg)
//			return true;

		return false;
		//	 for(Building b :infoModel.self().MyZone.FireZoneBuildings){
		//	 
		//	 int moveTime = gu.getFoolMoveTimeFromTo(infoModel.getAgent().me().getAreaPosition(),infoModel.getModel().searchWorldModel.getClusterData().getNearestBuildingToCenter()); 
		//	    int ReturnNum = Buildings.size() * moveTime *2;
		//	    int Return=0;
		//	    if(!myClusterBuildings.contains(infoModel.getAgent().me().getAreaPosition()) ){
		//	    Return =infoModel.getTime();
		//    }
		//		if(ReturnNum >= Return){
		//		GoToMyCluster();
		//		}
		//	 }

	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {

		if (infoModel.getLastSelectedBuilding() == null) {
			infoModel.Saba_Log.info("Skipped extinguish because of not having a building.");
			return null;
		}

		Building newTarget = updateFireZone();
		infoModel.Saba_Log.info("selected in extinguish is " + newTarget.getID());

//		if (GoToMyCluster()) {
//
//			infoModel.getLastSelectedBuilding().ExtinguishEnded = 0;
//			infoModel.setLastSelectedBuilding(null);
//			infoModel.getFireAgent().lastZone = infoModel.getFireAgent().MyZone;
//			infoModel.getFireAgent().ThereWasFireInMyCluster = infoModel.getFireAgent().TheresFireInMyCluster;
//			infoModel.getFireAgent().MyZone = null;
//			return null;
//
//		}

		if (infoModel.self().last_task != LastTask.ExtinguishTask && checkNecessary() && newTarget != null) {
			newTarget.ExtinguishStarted = 0;
			infoModel.setLastSelectedBuilding(newTarget);
		}
		else if (newTarget != null && infoModel.self().getVisibleEntities(Building.class).contains(newTarget))
			infoModel.setLastSelectedBuilding(newTarget);

		Building target = infoModel.getLastSelectedBuilding();

		if (target == null) {
			infoModel.Saba_Log.info("Extinguish: Skipped extinguish because of not having a building.");
			return null;
		}

		if (
		//			isExtinguished(infoModel) 
		!infoModel.self().isValid(infoModel.getLastSelectedBuilding())) {
			infoModel.Saba_Log.info("Extinguish: Skipped extinguish because the fire" + infoModel.getLastSelectedBuilding().getID() + "is already extinguished! (^_^) ");

			//			if( IntrruptBuilding != null &&  IntrruptBuilding.getID() == infoModel.getLastSelectedBuilding().getID())
			//				updateFireZone();
			infoModel.getLastSelectedBuilding().ExtinguishEnded = 0;
			infoModel.setLastSelectedBuilding(null);
			infoModel.getFireAgent().lastZone = infoModel.getFireAgent().MyZone;
			infoModel.getFireAgent().ThereWasFireInMyCluster = infoModel.getFireAgent().TheresFireInMyCluster;
			infoModel.getFireAgent().MyZone = null;
			return null;
		}

		//		if ((target.getFieryness() > 3 && target.getTemperature() < 10 && !infoModel.getMyCluster().getBuildings().contains(target))) {
		//			infoModel.setLastSelectedBuilding(null);
		//			infoModel.Saba_Log.info("Extinguish: Extinguished and not in my cluster so return null!");
		//			return null;
		//		}

		infoModel.getLog().info("selected = "+target);
		return infoModel.self().correctExtinguish(target, infoModel);

	}

	private boolean checkNecessary() {

		for (Building b : infoModel.getLastSelectedBuilding().realNeighbors_Building())
			if (b.getFieryness() == 0 || (b.getFieryness() > 3 && b.getFieryness() < 9))
				return false;
		return true;
	}

	private boolean isExtinguished(FireInformationModel infoModel) {
		if (infoModel.getLastSelectedBuilding().getTemperature() == 0)
			return true;

		if (infoModel.getLastSelectedBuilding().getFieryness() == 8)
			return true;

		return false;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public Building updateFireZone() {

		if (infoModel.getFireAgent().MyZone == null)
			return null;

		infoModel.getFireAgent().MyZone.setFireZoneNeighbours();

		for (Building b : infoModel.getFireAgent().MyZone.getFireZoneNeighbours()) {
			//			if(infoModel.self().isValid(b))
			//				infoModel.self().MyZone.FireZoneBuildings.add(b);

			infoModel.getFireAgent().MyZone.addBuildingToFireZone(b);
		}
		infoModel.Saba_Log.info("ssssssize "+ infoModel.getFireAgent().MyZone.FireZoneBuildings.size());

		infoModel.getFireAgent().sorted.setWeightBuildingsForMyCluster(infoModel.getFireAgent().MyZone.FireZoneBuildings);
		infoModel.self().MyZone.FireZoneBuildings=infoModel.getFireAgent().sorted.validBuildings;
		Collections.sort(infoModel.self().MyZone.FireZoneBuildings, new WeightComparator());
		//		printWeight(infoModel.self().MyZone.FireZoneBuildings);
		for(Building b: infoModel.self().MyZone.FireZoneBuildings){
		infoModel.Saba_Log.info(b.getID() + "print w=" + b.getWeight());
		}

		if (infoModel.self().MyZone.FireZoneBuildings.isEmpty())
			return null;

		infoModel.Saba_Log.info(infoModel.self().MyZone.FireZoneBuildings.get(0).getID() + "selected w=" + infoModel.self().MyZone.FireZoneBuildings.get(0).getWeight());
		return infoModel.self().MyZone.FireZoneBuildings.get(0);
	}

	public void printWeight(Vector<Building> fireZoneBuildings) {
		infoModel.Saba_Log.info("*******************" + infoModel.self().getID() + "********************");
		for (Building b : fireZoneBuildings)
			infoModel.Saba_Log.info("Building " + b.getID() + " //weight is: " + b.getWeight()
					+ " //Area : " + b.getTotalArea() + " //fireness : " + b.getFieryness() + "  //temp : " + b.getTemperature() +
					" //nc : " + b.getNeighbour_counter() + "  //estimate : " + b.BuildingEstimate);

	}
}
