package sos.fire_v2.Saba_States;

import java.util.Comparator;

import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.FireBrigade;
import sos.base.entities.StandardEntity;
import sos.base.util.SOSGeometryTools;
import sos.fire_v2.FireBrigadeAgent;
import sos.search_v2.tools.cluster.ClusterData;

public class FireComparator {

}

class DistanceComparator implements Comparator<ClusterData> {

	private SOSAgent<? extends StandardEntity> agent = null;

	public DistanceComparator(SOSAgent<? extends StandardEntity> agent) {
		this.agent = agent;
	}

	@Override
	public int compare(ClusterData o1, ClusterData o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}

class BuildingDistanceComparator implements Comparator<Building> {

	private SOSAgent<? extends StandardEntity> agent = null;

	public BuildingDistanceComparator(SOSAgent<? extends StandardEntity> agent) {
		this.agent = agent;
	}

	@Override
	public int compare(Building o1, Building o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}
class FireZoneDistanceComparator implements Comparator<FireBrigade > {

	private SFireZone fz = null;

	public FireZoneDistanceComparator(SFireZone fz) {
		this.fz = fz;
	}

	@Override
	public int compare(FireBrigade a1,FireBrigade a2) {
		double o1s = SOSGeometryTools.distance( fz.FireZoneBuildings.get(0).getX(), fz.FireZoneBuildings.get(0).getY(), a1.model().searchWorldModel.getClusterData(a1).getX(),  a1.model().searchWorldModel.getClusterData(a1).getY());
		double o2s = SOSGeometryTools.distance( fz.FireZoneBuildings.get(0).getX(), fz.FireZoneBuildings.get(0).getY() ,  a2.model().searchWorldModel.getClusterData(a2).getX(),  a2.model().searchWorldModel.getClusterData(a2).getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		
		
		
		return 0;
	}
}
class FireToBuildingDistanceComparator implements Comparator<FireBrigade > {

	private Building b = null;

	public FireToBuildingDistanceComparator(Building b) {
		this.b = b;
	}

	@Override
	public int compare(FireBrigade a1,FireBrigade a2) {
		double o1s = SOSGeometryTools.distance( b.getX(), b.getY(), a1.model().searchWorldModel.getClusterData(a1).getX(),  a1.model().searchWorldModel.getClusterData(a1).getY());
		double o2s = SOSGeometryTools.distance( b.getX(), b.getY() ,  a2.model().searchWorldModel.getClusterData(a2).getX(),  a2.model().searchWorldModel.getClusterData(a2).getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		
		
		
		return 0;
	}
}
class TempComparator implements Comparator<Building> {

	@Override
	public int compare(Building b1, Building b2) {

		if (b1.getTemperature() > b2.getTemperature())

			return -1;

		if (b1.getTemperature() < b2.getTemperature())

			return 1;

		return 0;

	}

}

class WeightComparator implements Comparator<Building> {

	@Override
	public int compare(Building b1, Building b2) {
		if (b1.getWeight() > b2.getWeight())

			return -1;

		if (b1.getWeight() < b2.getWeight())

			return 1;

		return 0;

	}
}

class FireZoneWeightComparator implements Comparator<SFireZone> {

	@Override
	public int compare(SFireZone f1, SFireZone f2) {
		if (f1.getFireZoneWeight() > f2.getFireZoneWeight())
			return -1;

		if (f1.getFireZoneWeight() < f2.getFireZoneWeight())
			return 1;

		return 0;

	}
}

class FireZoneSizeComparator implements Comparator<SFireZone> {

	@Override
	public int compare(SFireZone f1, SFireZone f2) {
		if (f1.FireZoneNeighbours.size() > f2.FireZoneNeighbours.size())
			return -1;

		if (f1.FireZoneNeighbours.size() < f2.FireZoneNeighbours.size())
			return 1;

		return 0;

	}
}
	class FirstPropComparator implements Comparator<Integer> {

		@Override
		public int compare(Integer p1, Integer p2) {
			if (p1 > p2)
				return -1;

			if (p1 < p2)
				return 1;

			return 0;

		}


	}

	class IdComparator implements Comparator<FireBrigade> {

		@Override
		public int compare(FireBrigade h1, FireBrigade h2) {
			if (h1.getID().getValue() < h2.getID().getValue())
				return 1;
			else if (h1.getID().getValue() > h2.getID().getValue())
				return -1;

			return 0;
		}
	}
	class AIdComparator implements Comparator<FireBrigadeAgent> {

		@Override
		public int compare(FireBrigadeAgent h1, FireBrigadeAgent h2) {
			if (h1.getID().getValue() < h2.getID().getValue())
				return 1;
			else if (h1.getID().getValue() > h2.getID().getValue())
				return -1;

			return 0;
		}
	}
