package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import sos.base.entities.Building;
import sos.base.entities.FireBrigade;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.fire_v2.decision.FireInformationModel;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class Interrupt extends SOSIState<FireInformationModel> {

	public Interrupt(FireInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		ArrayList<Building> VisibleFireyBuildings = new ArrayList<Building>();
		for (Building b : infoModel.self().getVisibleEntities(Building.class)) {
			if (b == null)
				continue;
			//	infoModel.Saba_Log.info("Intrrupt: Building " + b.getID() + " fireyness was: " + b.getFieryness() + " tempreture was: " + b.getTemperature());
			if (infoModel.self().isValid(b))
			{
				infoModel.Saba_Log.info("Interrupt: Building " + b.getID() + " was added to visibile firey buildings.");
				VisibleFireyBuildings.add(b);
			}
		}
		if (VisibleFireyBuildings.size() == 0)
		{
			infoModel.Saba_Log.info("Interrupt: Visibile Firey Buildings was empty so skip interrupt. :/ ");
			return null;
		}
		if (infoModel.self().last_task == LastTask.ExtinguishTask) {
			infoModel.Saba_Log.info("Intrrupt: Last task was extinguish so skip intrrupt.");
			return null;
		}
		if (infoModel.self().getVisibleEntities(Building.class).contains(infoModel.getLastSelectedBuilding())
				&& infoModel.self().isValid(infoModel.getLastSelectedBuilding()) ) {
			infoModel.Saba_Log.info("Interrupt: I am in the firezone I should be so I shouldn't extinguish it with intrrupt so skip intrrupt.  ");
			return null;
		}
		//		if (!ShouldIInterrupt())
		//		{
		//			infoModel.Saba_Log.info("Interrupt: I shouldn't interrupt so skip interrupt. ");
		//			return null;
		//		}

		if (infoModel.self().TheresFireInMyCluster && VisibleFireyBuildings.get(0).MyFireZone!=null && !VisibleFireyBuildings.get(0).MyFireZone.isSmall) {
//			infoModel.Saba_Log.info("Interrupt:  "+VisibleFireyBuildings.get(0).MyFireZone.FireZoneBuildings
//					+ "    size "+ VisibleFireyBuildings.get(0).MyFireZone.FireZoneNeighbours );
			infoModel.Saba_Log.info("Intrrupt: There was a fire in my cluster and this firezone was big so skip inttrupt. ");
			return null;
		}
		infoModel.Saba_Log.info("Intrrupt: In Intrrupt and weight is being set for intrrupt buildings. ");
		infoModel.Saba_Log.info("Interrupt: My zone is being changed to " + infoModel.self().MapsAllFireZones.indexOf(VisibleFireyBuildings.get(0).MyFireZone));
		infoModel.self().MyZone = VisibleFireyBuildings.get(0).MyFireZone;
//		infoModel.self().sorted.setWeightBuildingsForInttrupt(VisibleFireyBuildings);
//		Collections.sort(VisibleFireyBuildings, new WeightComparator());
		infoModel.Saba_Log.info("Interrupt: Last selected building is : " + VisibleFireyBuildings.get(0));
		VisibleFireyBuildings.get(0).ExtinguishStarted =0;
		infoModel.setLastSelectedBuilding(VisibleFireyBuildings.get(0));
		infoModel.self().IntrruptBuilding = VisibleFireyBuildings.get(0);
		return null;

	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean ShouldIInterrupt() {
		Vector<FireBrigade> allFireBrigadesInMyVisibileEntityBrigades = new Vector<FireBrigade>();
		for (FireBrigade f : infoModel.self().getVisibleEntities(FireBrigade.class))
			allFireBrigadesInMyVisibileEntityBrigades.add(f);
		if (allFireBrigadesInMyVisibileEntityBrigades.size() == 0)
			return true;
		int bestFireBrigadeToInterruptID = -1;
		for (FireBrigade f : allFireBrigadesInMyVisibileEntityBrigades) {
			if (f.getID().getValue() > bestFireBrigadeToInterruptID)
				bestFireBrigadeToInterruptID = f.getID().getValue();

		}

		infoModel.Saba_Log.info("Interrupt: Best firebrigade to extinguish is: Agent " + bestFireBrigadeToInterruptID);
		if (bestFireBrigadeToInterruptID != infoModel.self().getID().getValue())
			return false;

		return true;

	}

}
