package sos.fire_v2.Saba_States;

import java.util.List;

import rescuecore2.geometry.GeometryTools2D;
import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.fire_v2.FireBrigadeAgent;
import sos.fire_v2.decision.FireInformationModel;
import sos.fire_v2.decision.tasks.ExtinguishTask;
import sos.tools.Utils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

//DONE
public class LowHP_FullWater extends SOSIState<FireInformationModel> {

	public LowHP_FullWater(FireInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		if (checkLowWater() && !isHPLow()) {
			infoModel.Saba_Log.info("LH-FW: Skipped LowHP_FullWater (>_<) ");
			return null;

		}

		Decide d = new Decide(infoModel);
		if (d.choose() != null) {
			infoModel.Saba_Log.info("LH-FW: sabaMove because there's a selected building. ");
			d.choose().ExtinguishStarted = 0;
			infoModel.setLastSelectedBuilding(d.choose());
			if (GeometryTools2D.getDistance(infoModel.self().me().getPositionPoint(), infoModel.getLastSelectedBuilding().getPositionPoint()) <
					(infoModel.self().maxDistance)) {
				infoModel.self().last_task=LastTask.ExtinguishTask;
				return new ExtinguishTask(infoModel.getLastSelectedBuilding(), null, infoModel.getTime());
			}
			infoModel.self().last_task=LastTask.sabaMove;
			return new sabaMove(null, infoModel.getTime(), d.choose());
		}

		infoModel.Saba_Log.info("LH-FW: Search cause there wasn't any available building. ");
		return new SabaSearchTask(null, infoModel.getTime(), infoModel);

	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isHPLow() {

		if (getDeathTime() - infoModel.getTime() < getTimeToNearestRefuge() + 10)
			return true;

		return false;
	}

	public boolean checkLowWater() {
		if (infoModel.getFireBrigadeEntity().getWater() <  (   (FireBrigadeAgent) (infoModel.getAgent() ) ).maxPower)
			return true;

		return false;

	}

	public int getDeathTime() {

		return SimpleDeathTime.getEasyLifeTime(infoModel.getFireBrigadeEntity().getHP(), infoModel.getFireBrigadeEntity().getDamage(), infoModel.getTime());

	}

	public int getTimeToNearestRefuge() {
		sos.base.move.Path path = infoModel.getAgent().move.getPathFromTo(java.util.Collections.singleton(infoModel.getEntity().getAreaPosition()), infoModel.getModel().refuges(), StandardMove.class);
		return Utils.getSampleTimeToTarget(path);
	}

}
