package sos.fire_v2.Saba_States;

import java.util.List;

import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.Refuge;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.fire_v2.decision.FireInformationModel;
import sos.fire_v2.decision.tasks.FireRestTask;
import sos.fire_v2.decision.tasks.goToRefuge;
import sos.tools.Utils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

///DONE
public class LowHP_LowWater extends SOSIState<FireInformationModel> {

	public LowHP_LowWater(FireInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		if (!checkLowWater() && !isHPLow()) {
			infoModel.Saba_Log.info("LH-LW: Skipped LowHP_LowWater");
			return null;
		}

		infoModel.Saba_Log.info("LH-LW: LowHp_LowWater is selected so I'm going to refuge (X_X) ");
		infoModel.self().last_task=LastTask.goToRefuge;
		if (!(infoModel.self().me().getAreaPosition() instanceof Refuge))
			return new goToRefuge(null, infoModel.getTime());

		return new FireRestTask(null, infoModel.getTime());

	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isHPLow() {

		if (getDeathTime() - infoModel.getTime() < getTimeToNearestRefuge() + 10)
			return true;

		return false;
	}

	public boolean checkLowWater() {
		infoModel.Saba_Log.info("LH-LW: Waterquantity is: " + infoModel.getFireBrigadeEntity().getWater());
		if (infoModel.getFireBrigadeEntity().getWater() ==0) {
			infoModel.Saba_Log.info("LH-LW: checkLowWater returned true. *+* ");
			return true;
		}
		infoModel.Saba_Log.info("LH-LW: checkLowWater returned false (^_^)"  );
		return false;

	}

	public int getDeathTime() {
		infoModel.Saba_Log.info("LH-LW: DeathTime is: " + SimpleDeathTime.getEasyLifeTime(infoModel.getFireBrigadeEntity().getHP(), infoModel.getFireBrigadeEntity().getDamage(), infoModel.getTime()) );
		return SimpleDeathTime.getEasyLifeTime(infoModel.getFireBrigadeEntity().getHP(), infoModel.getFireBrigadeEntity().getDamage(), infoModel.getTime());

	}

	public int getTimeToNearestRefuge() {
		sos.base.move.Path path = infoModel.getAgent().move.getPathFromTo(java.util.Collections.singleton(infoModel.getEntity().getAreaPosition()), infoModel.getModel().refuges(), StandardMove.class);
		infoModel.Saba_Log.info("LH-LW: Time to nearest refuge is: " + Utils.getSampleTimeToTarget(path) );
		return Utils.getSampleTimeToTarget(path);
	}

}
