package sos.fire_v2.Saba_States;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import sos.base.entities.Hydrant;
import sos.base.entities.Refuge;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.fire_v2.decision.FireInformationModel;
import sos.fire_v2.decision.tasks.FireRestTask;
import sos.fire_v2.decision.tasks.goToRefuge;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

//DONE
public class No_Water extends SOSIState<FireInformationModel> {

	public No_Water(FireInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {

		if (infoModel.getFireBrigadeEntity().getWater() != 0 && !(infoModel.self().me().getAreaPosition() instanceof Refuge)) {
	//		infoModel.Saba_Log.info("Skipped No Water");

			return null;
		}

		if (infoModel.getFireBrigadeEntity().getWater() == infoModel.self().maxWater && (infoModel.self().me().getAreaPosition() instanceof Refuge))
			return null;

	//	infoModel.Saba_Log.info("Going to refuge because of no water");
		infoModel.self().last_task = LastTask.goToRefuge;
		if (!(infoModel.self().me().getAreaPosition() instanceof Refuge)) {
			if (!infoModel.self().model().refuges().isEmpty()){
			
				if (infoModel.getFireBrigadeEntity().getWater() >= infoModel.self().maxPower) {
			//		infoModel.Saba_Log.info("HHLW:skipped go to Hydrant because of high water");
					return null;
				}
				return new goToRefuge(null, infoModel.getTime());
			}
		}
		if(!(infoModel.self().me().getAreaPosition() instanceof Hydrant)){
			if (!infoModel.self().model().refuges().isEmpty()){
				
				if (infoModel.getFireBrigadeEntity().getWater() >= infoModel.self().maxPower) {
				//	infoModel.Saba_Log.info("HHLW:skipped go to Hydrant because of high water");
					return null;
				}
				return new goToHydrant(null, infoModel.getTime());
		    }
		}
	    int cycle2=findRefuge();
		int cycle1= findHydrants();
		if (cycle1<cycle2 && findHydrants() != 100){
//			return new goToHydrant(ChooseBestHydrant(), infoModel.getTime());

//			agent.move.move(ChooseBestHydrant(),StandardMove.class);
			infoModel.Saba_Log.info("moveing to Hydrant!!!!!!");			
			infoModel.getMove().moveStandard(ChooseBestHydrant());
//			return new goToHydrant(ChooseBestRefuge(), infoModel.getTime());
		}
		else 
//			return new goToRefuge(ChooseBestRefuge()infoModel.getTime());
//		return new goToRefuge(ChooseBestRefuge(), infoModel.getTime());
			infoModel.getMove().moveStandard(ChooseBestRefuge());


		
		return new FireRestTask(null, infoModel.getTime());
	}

private int findRefuge(){

	   ArrayList<Refuge>r=new ArrayList<Refuge>();
	   for (Refuge R:infoModel.getModel().refuges())

			if(R.isReallyReachable(true)){
				r.add(R);
			}	
		
		if(r.isEmpty())
			return 100 ;
	
	sos.base.move.Path path = infoModel.getAgent().move.getPathFromTo(java.util.Collections.singleton(infoModel.getAgent().me().getAreaPosition()), r, StandardMove.class);
	int cycle2 = sos.tools.Utils.getSampleTimeToTarget(path);
	return cycle2;

	}

	 private int findHydrants() {


				
				ArrayList<Hydrant> valids=new ArrayList<Hydrant>();
				
				for(Hydrant h:infoModel.getModel().Hydrants()){
					
					if(h.isReallyReachable(true)){
						valids.add(h);
					}	
				}
				if(valids.isEmpty())
					return 100;
			
					sos.base.move.Path path = infoModel.getAgent().move.getPathFromTo(java.util.Collections.singleton(infoModel.getAgent().me().getAreaPosition()), valids, StandardMove.class);
					int cycle1 = sos.tools.Utils.getSampleTimeToTarget(path);
				
			if(cycle1 < 3)
			 return cycle1;
			return 100;

	   
	 }
	 private Hydrant ChooseBestHydrant()  {
		 Hydrant BestHydrant=null;
		 Double minDis=(double) 19999;
		 for(Hydrant g:infoModel.getModel().Hydrants()){
			 if(g.isReallyReachable(true)){
				 Double distance=Point.distance(g.getX(), g.getY(),infoModel.getAgent().me().getAreaPosition().getX(),infoModel.getAgent().me().getAreaPosition().getY());
				 if (distance<minDis){
					 minDis=distance;
					 BestHydrant=g;
				 }
			 }
		 }
		 return BestHydrant;
	 }
	 private Refuge ChooseBestRefuge()  {
		 Refuge BestRefuge=null;
		 Double minDis=(double) 19999;
		 for(Refuge q:infoModel.getModel().refuges()){
			 if(q.isReallyReachable(true)){
				 Double distance=Point.distance(q.getX(), q.getY(),infoModel.getAgent().me().getAreaPosition().getX(),infoModel.getAgent().me().getAreaPosition().getY());
				 if (distance<minDis){
					 minDis=distance;
					 BestRefuge=q;
				 }
			 }
		 }
		 return BestRefuge;
	 }
	 
	 
		
		

	   
	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
