package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Vector;

import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.FireBrigade;
import sos.base.util.SOSGeometryTools;
import sos.fire_v2.FireBrigadeAgent;
import sos.search_v2.tools.cluster.ClusterData;

public class SFireZone {

	private static final float MAX_VALUE = 0;
	public ArrayList<Building> FireZoneBuildings = new ArrayList<Building>();
	public ArrayList<Building> others=new ArrayList<Building>();
	Vector<Building> FireZoneNeighbours = new Vector<Building>();
	ArrayList<FireBrigade> Helpers = new ArrayList<FireBrigade>();
	public ArrayList<ClusterData> fzClusters = new ArrayList<ClusterData>();

	FireBrigadeAgent agent;
	public boolean isSmall = true;
	private int FireZoneTotalArea = 0;
	private int FireZoneWeight = 1;
	float Prop = 1;
	int NumberOfNeededAgents = 0;
	public int EstimateSize = 0;
	public float TotalBuildingWeight = 0;
	public int NumberOfGasstation = 0;
	public float distanceFromCenter;
	public int NumberOfNeighbors;
	public int NumberOfCivilians;
	public Building NearestBuildingToCenter;

	public SFireZone(FireBrigadeAgent fire) {

		this.agent = fire;
	}

	public void addBuildingToFireZone(Building b) {

		ClusterData buildingCluster = findBuildingCluster(b);
		if (!fzClusters.contains(buildingCluster))
			fzClusters.add(buildingCluster);
		//		agent.Saba_Log.info("SFireZone: addBuildingToFireZone was called for  " + b.getID() + "  neighbours size is: " + b.realNeighbors_Building().size() + " neighbour counter was: " + b.getNeighbour_counter());
		for (Area a : b.realNeighbors_Building()) {
			Vector<Area> RoadsNeighbours = new Vector<Area>();
			//			agent.Saba_Log.info("SFireZone: " + a);
			/*
			 * if (a instanceof Road) {
			 * agent.Saba_Log.info("SFireZone: Area " + a.getID() + " was instance of road. Neighbours size is: " + a.getNeighbours() );
			 * RoadsNeighbours.addAll(a.getNeighbours());
			 * for (Area a2 : RoadsNeighbours) {
			 * if (!(a2 instanceof Building))
			 * continue;
			 * agent.Saba_Log.info("SFireZone: Area " + a2.getID());
			 * Building b3 = (Building) a2;
			 * if (b3.getTemperature() < 20)
			 * continue;
			 * if (b3.getFieryness() == 8)
			 * continue;
			 * if (FireZoneBuildings.contains(b3)){
			 * agent.Saba_Log.info("SFireZone: Building " + b3.getID() + " was added already. ");
			 * continue;
			 * }
			 * FireZoneBuildings.add(b3);
			 * agent.Saba_Log.info("SFireZone: Building " + b3.getID() + " is added.");
			 * addBuildingToFireZone(b3);
			 * }
			 * }
			 */

			if (!(a instanceof Building))
			{
				//			agent.Saba_Log.info(" wasn't instance of building.");
				continue;

			}
			Building b2 = (Building) a;
			if (FireZoneBuildings.contains(b2)) {
				//			agent.Saba_Log.info(" already added.");
				continue;
			}

			if(others.contains(b2))
				continue;
			if (!agent.isValid(b2))
				continue;

			if (b2.getFieryness() > 0 && b2.getFieryness() < 4)
				FireZoneBuildings.add(b2);
			else
				others.add(b2);
			//		agent.Saba_Log.info("SFireZone: Building " + b2.getID() + " is added.");
			setFireZoneTotalArea(b2.getTotalArea());
			addBuildingToFireZone(b2);

		}

	}

	public ClusterData findBuildingCluster(Building b) {
		float minClusterDis = 99999;
		ClusterData result = null;
		ClusterData C = null;
		for (ClusterData c : agent.model().searchWorldModel.getAllClusters()) {
			float d2 = (float) SOSGeometryTools.distance(c.getNearestBuildingToCenter(), b);
			if (d2 < minClusterDis) {
				minClusterDis = d2;
				C = c;
			}
		}

		return result;
	}

	public int getFireZoneTotalArea() {
		return FireZoneTotalArea;
	}

	public void setFireZoneTotalArea(int BuildingTotalArea) {

		FireZoneTotalArea = FireZoneTotalArea + BuildingTotalArea;
	}

	public int getFireZoneWeight() {
		return FireZoneWeight;
	}

	public void setFireZoneWeight(int fireZoneWeight) {
		FireZoneWeight = fireZoneWeight;
	}

	public void setFireZoneNeighbours() {
		FireZoneNeighbours.clear();
		for (Building b : FireZoneBuildings)
			for (Area n : b.realNeighbors_Building()) {
				if (!(n instanceof Building))
					continue;

				Building n1 = (Building) n;
				if (FireZoneNeighbours.contains(n1))
					continue;
				FireZoneNeighbours.add(n1);

			}

	}

	public Vector<Building> getFireZoneNeighbours() {
		return FireZoneNeighbours;
	}

	public void setProp(float sumWeight) {
		Prop = FireZoneWeight / sumWeight;
	}

	public void setNumberOfNeededAgents(int helpers) {
		float f = (helpers * Prop);
		//		agent.Saba_Log.info("SFireZone: Before ceil: " + f + "  helpers size = " + helpers);
		NumberOfNeededAgents = (int) Math.ceil(f);
	}

	public void setSize() {

		if (FireZoneBuildings.size() > 5 && FireZoneNeighbours.size() > 20)
			isSmall = false;
		else if (FireZoneNeighbours.size() > 35)
			isSmall = false;
		else
			isSmall = true;

	}

}
