package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;

import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.Human;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.base.util.geom.ShapeInArea;
import sos.fire_v2.decision.FireInformationModel;
import sos.tools.decisionMaker.definitions.commands.SOSITarget;
import sos.tools.decisionMaker.definitions.commands.SOSTask;

public class SabaSearchSideTask extends SOSTask<SOSITarget> {

	FireInformationModel infoModel;
	ArrayList<Building> searchBuildings=new ArrayList<Building>();
	public SabaSearchSideTask(SOSITarget target,ArrayList<Building> s, int creatinTime, FireInformationModel f) {
		super(target, creatinTime);
		infoModel = f;
		searchBuildings.clear();
		this.searchBuildings.addAll(s);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSITarget getTarget() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void execute(SOSAgent<? extends Human> agent) throws SOSActionException {

		if (infoModel.self().last_task == LastTask.SabaSearchTask) {
			infoModel.Saba_Log.info("SabaSearchSideTask: Last task was sabaSearch. ^_^");
			
			if (infoModel.self().searchBuildingTarget != null && !infoModel.self().searchBuildingTarget.getChecked()) {
				infoModel.Saba_Log.info("SabaSearchSideTask: Has a target ^_^");
				if (SOSGeometryTools.distance(infoModel.self().me().getAreaPosition(), infoModel.self().searchBuildingTarget) < infoModel.self().maxDistance / 2) {
					infoModel.Saba_Log.info("SabaSearchSideTask: Distance was close so it's considered being search. ^_^");
					infoModel.self().searchBuildingTarget.setChecked(true);
					for(Building b: infoModel.self().getVisibleEntities(Building.class)){
						b.setChecked(true);
					}
					infoModel.self().searchBuildingTarget = null;
				}
				else {
					infoModel.Saba_Log.info("SabaSearchSideTask: Distance was'nt close so it's going there. :/ "+ infoModel.self().searchBuildingTarget);
					infoModel.self().last_task=LastTask.SabaSearchTask;
					infoModel.self().move.move(infoModel.self().searchBuildingTarget, StandardMove.class);
				}
			}
		}
		
		infoModel.Saba_Log.info("SabaSearchSideTask: searchBuildings are: " + searchBuildings);
		chooseBuilding(searchBuildings);

	}

	private void chooseBuilding(ArrayList<Building> buildings) throws SOSActionException {
		Collections.sort(buildings, new BuildingDistanceComparator(infoModel.getAgent()));
		Building last = null;
		int counter = 0;
		int myP = infoModel.self().myPlaceInGroup();
		for (Building b : buildings) {

			if (b == null)
				continue;
			if(b.getFieryness() ==8){
				b.setChecked(true);
				continue;
				
				
			}
			if (b.getChecked()) {
			infoModel.Saba_Log.info("SabaSearchTask: Builidng id= " + b.getID() + "in neighbour clusters buildings was checked so continue. ");
				continue;
			}
			
//			if(!taskIsValid(b)){
//				infoModel.Saba_Log.info("SabaSearchSideTask: Builiding id=  " + b.getID() + " wasn't reachable so continue. ");
//				continue;
//				}
			if (myP != -1 && counter < myP) {
				infoModel.Saba_Log.info("SabaSearchSideTask: I shouldn't search. ");
				counter++;
				last = b;
				continue;
			}
			infoModel.self().searchBuildingTarget = b;
			infoModel.Saba_Log.info("SabaSearchSideTask: Builidng id= " + b.getID() + "in neighbour clusters buildings wasn't checked so moving to this building. ");
			infoModel.self().last_task=LastTask.SabaSearchTask;
			infoModel.self().move.moveToShape(b.getSearchAreas(), StandardMove.class);
		}
		

	}


	private boolean taskIsValid(Building b) {

		infoModel.Saba_Log.info("SabaSearchSideTask: Builidng id= " + b.getID() );
		for (ShapeInArea sia : b.getSearchAreas()) {
			infoModel.Saba_Log.info("SabaSearchSideTask: getSearchAreas = " + sia.getArea() );
			if (sia.getArea().isReallyReachable(true))
				return true;
			
		}

		return false;
	}
	
}
