package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;

import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.Human;
import sos.base.move.types.StandardMove;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.base.util.geom.ShapeInArea;
import sos.fire_v2.FireBrigadeAgent;
import sos.fire_v2.decision.FireInformationModel;
import sos.tools.decisionMaker.definitions.commands.SOSITarget;
import sos.tools.decisionMaker.definitions.commands.SOSTask;

public class SabaSearchTask extends SOSTask<SOSITarget> {

	FireInformationModel infoModel;
	ArrayList<Building> MyClusterBuildings;
	ArrayList<Building> NeighbourClustersBuildings = new ArrayList<Building>();

	public SabaSearchTask(SOSITarget target, int creatinTime, FireInformationModel f) {
		super(target, creatinTime);
		infoModel = f;
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSITarget getTarget() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void execute(SOSAgent<? extends Human> agent) throws SOSActionException {

		isAllChecked();
		if (infoModel.self().last_task == LastTask.SabaSearchTask) {
			infoModel.Saba_Log.info("SabaSearchTask: Last task was sabaSearch. ^_^");
			if (infoModel.self().searchBuildingTarget != null && !infoModel.self().searchBuildingTarget.getChecked()) {
				infoModel.Saba_Log.info("SabaSearchTask: Has a target ^_^");
				if (SOSGeometryTools.distance(infoModel.self().me().getAreaPosition(), infoModel.self().searchBuildingTarget) < infoModel.self().maxDistance / 2) 
				{
					//infoModel.Saba_Log.info("SabaSearchTask: Distance was close so it's considered being search. ^_^");
					infoModel.self().searchBuildingTarget.setChecked(true);
					for(Building b: infoModel.self().getVisibleEntities(Building.class)){
						b.setChecked(true);
					}
					infoModel.self().searchBuildingTarget = null;
				}
				else{
					//infoModel.Saba_Log.info("SabaSearchTask: Distance was'nt close so it's going there. :/ "+ infoModel.self().searchBuildingTarget);
					infoModel.self().last_task=LastTask.SabaSearchTask;
					infoModel.self().move.moveToShape(infoModel.self().searchBuildingTarget.getSearchAreas(), StandardMove.class);
				}
				
			}
		}

		Building last = null;
		int counter = 0;
		int myP = infoModel.self().myPlaceInGroup();
		for (Building b : infoModel.getMyCluster().getBuildings()) {
			last = b;
			if (b.getChecked()) {
				infoModel.Saba_Log.info("SabaSearhTask: Building id " + b.getID() + " in its own cluster, checked was false. ");
				continue;
			}
			if (myP != -1 && counter < myP) {
				counter++;
				continue;
			}

			infoModel.self().searchBuildingTarget = b;
			infoModel.Saba_Log.info("SabaSearchTask: Builidng id= " + b.getID() + "in my cluster buildings wasn't checked so moving to this building. ");
			infoModel.self().last_task=LastTask.SabaSearchTask;
			infoModel.self().move.moveToShape(b.getSearchAreas(), StandardMove.class);
		}

		infoModel.self().sorted.clusterDistanceSorting();
		NeighbourClustersBuildings.addAll(infoModel.self().sorted.getArgumentSortedCluster(0).getBuildings());
		NeighbourClustersBuildings.addAll(infoModel.self().sorted.getArgumentSortedCluster(1).getBuildings());
		NeighbourClustersBuildings.addAll(infoModel.self().sorted.getArgumentSortedCluster(2).getBuildings());
		NeighbourClustersBuildings.addAll(infoModel.self().sorted.getArgumentSortedCluster(3).getBuildings());
		NeighbourClustersBuildings.addAll(infoModel.self().sorted.getArgumentSortedCluster(4).getBuildings());
		infoModel.Saba_Log.info("SabaSearchTask: Neighbour clusters builidings are: " + NeighbourClustersBuildings);
		chooseBuilding(NeighbourClustersBuildings);

	}

	private void chooseBuilding(ArrayList<Building> buildings) throws SOSActionException {
		Collections.sort(buildings, new BuildingDistanceComparator(infoModel.getAgent()));
		Building last = null;
		int counter = 0;
		int myP = infoModel.self().myPlaceInGroup();
		for (Building b : buildings) {

			if (b == null)
				continue;
			
			if(b.getFieryness() ==8){
				b.setChecked(true);
				continue;
				
				
			}
			if (b.getChecked()) {
				//infoModel.Saba_Log.info("SabaSearchTask: Builidng id= " + b.getID() + "in neighbour clusters buildings was checked so continue. ");
				continue;
			}
			if(!taskIsValid(b))
				continue;
			if (myP != -1 && counter < myP) {
				counter++;
				last = b;
				continue;
			}
			infoModel.self().searchBuildingTarget = b;
			infoModel.Saba_Log.info("SabaSearchTask: Builidng id= " + b.getID() + "in neighbour clusters buildings wasn't checked so moving to this building. ");
			infoModel.self().last_task=LastTask.SabaSearchTask;
			infoModel.self().move.moveToShape(b.getSearchAreas(), StandardMove.class);
		}

	}

	private boolean taskIsValid(Building b) {

		for (ShapeInArea sia : b.getSearchAreas()) {
			if (sia.getArea().isReallyReachable(true))
				return true;
		}

		return false;
	}

	public void isAllChecked() {

		for (Building b : infoModel.getMyCluster().getBuildings()) {
			if (b == null)
				continue;
			if (b.getChecked())
				continue;
			infoModel.self().searchBuildingTarget = b;
			return;
		}
		((FireBrigadeAgent) infoModel.getAgent()).lastSearchCycle++;

		if (((FireBrigadeAgent) infoModel.getAgent()).lastSearchCycle > 20) {
			((FireBrigadeAgent) infoModel.getAgent()).lastSearchCycle = 0;
			makeFalse();
		}
	}

	public void makeFalse() {

		for (Building b : infoModel.getMyCluster().getBuildings())
			b.setChecked(false);
	}

}
