package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Vector;

import sos.base.entities.Building;
import sos.base.entities.FireBrigade;
import sos.base.entities.Refuge;
import sos.fire_v2.decision.FireInformationModel;
import sos.search_v2.tools.cluster.ClusterData;

public class Sort {

	FireInformationModel infoModel;
	public ArrayList<Building> validBuildings = new ArrayList<Building>();
	ArrayList<ClusterData> clusters = new ArrayList<ClusterData>();
	public Weight weight;
	FireZoneWeight firezoneWeight;

	public Sort(FireInformationModel infoModel) {

		this.infoModel = infoModel;
		setBuildings();
		clusters.addAll(infoModel.self().model().searchWorldModel.getAllClusters());
		weight = new Weight(infoModel);
		firezoneWeight = new FireZoneWeight(infoModel);
	}

	public void setBuildings() {
		validBuildings.clear();
		
	//	infoModel.Saba_Log.info("Sort : ********** set Buildings ************");
		for (Building b : infoModel.getModel().buildings()) {
			if (b == null)
				continue;
			
			if(!b.isTemperatureDefined()){
//				infoModel.Saba_Log.info("Sort: id = " + b.getID()+"temp not defined");
				continue;
			}
			if(!b.isFierynessDefined()){
//				infoModel.Saba_Log.info("Sort: id = " + b.getID()+" Fieryness not defined");
				continue;
			}
//			if(!b.isIgnitionDefined()){
//				infoModel.Saba_Log.info("id = " + b.getID()+" ignition not defined" );
//				continue;
//			}
//			if(!b.isReallyReachable(true)){
//				infoModel.Saba_Log.info("id = " + b.getID()+ "not reachable");
//				continue;
//			}
				//clusterData.getBuilding
			if(!infoModel.self().isValid(b))
				continue;
			
			if(b instanceof Refuge)
			continue;
			
			validBuildings.add(b);
			//infoModel.Saba_Log.info("Sort: This building was added to valid buildings: " + b.getID());
		}
	//	infoModel.Saba_Log.info("********** ************* ************");
	}

	public void callWeight() {
		weight.setWeights(validBuildings);
		validBuildings=weight.Buildings;

//		weight.resetWeights();
//		weight.Area();
//		weight.FireyNess();
//		weight.Neighbours();
//		weight.HighTemp();
//		weight.saveGasStation();
//		weight.WeightEstimate();

		

	}
	

	public void callFireZoneWeight(Vector<SFireZone> MapsAllFireZones){
		
		firezoneWeight.Area(MapsAllFireZones);
		firezoneWeight.BuildingsInAFireZone(MapsAllFireZones);
		firezoneWeight.callEstimate(MapsAllFireZones);
	//	firezoneWeight.SetFireZoneWeight(MapsAllFireZones);
		Collections.sort(MapsAllFireZones, new FireZoneWeightComparator());
		for(SFireZone fz: MapsAllFireZones){
			infoModel.Saba_Log.info("Firezone number " + MapsAllFireZones.indexOf(fz) + " buildings are: ");
				for(Building b: fz.FireZoneBuildings)
					infoModel.Saba_Log.info(b.getID());
		}
	}
	public void setWeightBuildings(Vector<SFireZone> MapsAllFireZones){
		if(MapsAllFireZones.isEmpty())
			return;
		validBuildings =new ArrayList<Building>();
		callFireZoneWeight(MapsAllFireZones);
		Collections.sort(MapsAllFireZones, new FireZoneWeightComparator());
		validBuildings =new ArrayList<Building>();
		validBuildings.addAll(MapsAllFireZones.get(0).FireZoneBuildings);
		callWeight();
		Collections.sort(validBuildings, new WeightComparator());
		
	}

	public void setWeightBuildingsForMyCluster(ArrayList<Building> fff){
		infoModel.Saba_Log.info("**************"+ fff.size());
		validBuildings=new ArrayList<Building>();
		validBuildings.addAll(fff);

		//infoModel.Saba_Log.error("size"+validBuildings.size());
		infoModel.Saba_Log.info("**************"+ validBuildings.size());
		callWeight();
		Collections.sort(validBuildings, new WeightComparator());
	}
	public void setWeightBuildingsForInttrupt(ArrayList<Building> IntrruptBuildings ){
		validBuildings = new ArrayList<Building>();
		validBuildings.addAll(IntrruptBuildings);
		callWeight();
	//	Collections.sort(validBuildings, new WeightComparator());
	}
	public void setWeightBuildingsForHelping(SFireZone HelpingFireZone){
		validBuildings = new ArrayList<Building>();
		validBuildings.addAll(HelpingFireZone.FireZoneBuildings);
		callWeight();
		Collections.sort(validBuildings, new WeightComparator());
	}
	public void weightSorting() {
		setBuildings();
		callWeight();
		Collections.sort(validBuildings, new WeightComparator());
	}

	public void buildingDistanceSorting() {

		Collections.sort(validBuildings, new BuildingDistanceComparator(infoModel.getAgent()));
	}

	public void clusterDistanceSorting() {

		clusters.clear();
		clusters.addAll(infoModel.self().model().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new DistanceComparator(infoModel.getAgent()));

	}

	public Building getFirstSortedBuilding() {
		if (!validBuildings.isEmpty())
			return validBuildings.get(0);
		
		return null;

	}

	public ClusterData getFirstSortedCluster() {

		return clusters.get(0);
	}

	public void getAllBuildingsWeight() {

		for (Building b : validBuildings)
			infoModel.Saba_Log.info("Sort: BuildingID: " + b.getID() + " BuildingWeight: " + b.getWeight() +
					" temp :" + b.getTemperature() + " firyness :" + b.getFieryness() + " area : " + b.getTotalArea() + " neighbour :" + b.getNeighbour_counter());

	}
	public ClusterData getArgumentSortedCluster(int i){
		
		if(clusters.get(i)!=null)
		return clusters.get(i) ;
		
		return null;

	}
	
	public ArrayList<FireBrigade> sortID(ArrayList<FireBrigade> l){
	
		Collections.sort(l, new IdComparator());
		
		return l;
		
		
	}

}
