package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.geometry.GeometryTools2D;
import rescuecore2.geometry.Point2D;
import sos.base.entities.Building;
import sos.base.entities.Refuge;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.base.util.information_stacker.CycleInformations;
import sos.base.util.information_stacker.act.MoveAction;
import sos.fire_v2.decision.FireInformationModel;
import sos.fire_v2.decision.tasks.ExtinguishTask;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class Stuck extends SOSIState<FireInformationModel> {

	public Stuck(FireInformationModel infoModel) {
		super(infoModel);

	}

	ArrayList<Building> FiresInMaxDistanceStuck = new ArrayList<Building>();
	ArrayList<Building> MapsAllNeededFireBuildings = new ArrayList<Building>();
	Weight weightB = new Weight(infoModel);

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		if (infoModel.getTime() < 5)
			return null;

		if (!IAmStuck()) {
			infoModel.Saba_Log.info("Stuck: I'm not stuck so skip stuck. :) ");
			return null;
		}

		FireBuildingsInVisible();
		if (!FiresInMaxDistanceStuck.isEmpty()) {

			weightB.setWeights(FiresInMaxDistanceStuck);
			Collections.sort(FiresInMaxDistanceStuck, new WeightComparator());
			return new ExtinguishTask(FiresInMaxDistanceStuck.get(0), null, infoModel.getTime());
		}
		if ((infoModel.self().last_task == LastTask.SabaSearchTask && infoModel.self().searchBuildingTarget != null) || infoModel.self().last_task == LastTask.sabaMove) {
			infoModel.Saba_Log.info("Stuck: Last task wasn't SabaSearchTask so skip stuck. ");
			if(infoModel.self().searchBuildingTarget != null)
			infoModel.self().searchBuildingTarget.setChecked(true);
			infoModel.self().searchBuildingTarget = null;
		}
		if (infoModel.getLastSelectedBuilding() != null) {
			infoModel.Saba_Log.info("Stuck: SearchBuildingTarget was null so skip stuck. ");
			infoModel.setLastSelectedBuilding(null);
		}

		infoModel.Saba_Log.info("Stuck: Agent was stucked going to building so search ");

		return new SabaSearchTask(null, infoModel.getTime(), infoModel);
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean IAmStuck() {
		List<Point2D> positions = new ArrayList<Point2D>();
		if (infoModel.getTime() > 10) {
			for (int i = 1; i <= 5; i++) {
				CycleInformations act = infoModel.getAgent().informationStacker
						.getInformations(i);
				if (act.getAct() instanceof MoveAction)
					positions.add(act.getPositionPair().second());
			}
		}
		int numberOfNearPosition = 0;
		for (int i = 0; i < positions.size(); i++) {
			int minDistanceToThere = getdistanceToHere(positions.get(i));
			if (minDistanceToThere < 1000)
				numberOfNearPosition++;
		}

		if (numberOfNearPosition >= 3)
			return true;
		return false;

	}

	private int getdistanceToHere(Point2D point2d) {
		int minDistance = SOSGeometryTools.distance(point2d, infoModel
				.self().me().getPositionPoint());
		return minDistance;
	}

	public void FireBuildingsInVisible() {

		MapsAllNeededFireBuildings.clear();
		FiresInMaxDistanceStuck.clear();
		for (Building b : infoModel.self().model().buildings()) {
			if (!infoModel.self().isValid(b))
				continue;
			if (b.getFieryness() != 1)
				continue;

			MapsAllNeededFireBuildings.add(b);
		}
		for (Building b : MapsAllNeededFireBuildings) {
			if (GeometryTools2D.getDistance(infoModel.self().me().getPositionPoint(), b.getPositionPoint()) > (infoModel.self().maxDistance))
				continue;
			if (b instanceof Refuge)
				continue;

			FiresInMaxDistanceStuck.add(b);
		}

	}
}
