package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Vector;

import rescuecore2.geometry.Point2D;
import sos.base.entities.Building;
import sos.base.entities.GasStation;
import sos.base.entities.Refuge;
import sos.base.util.SOSGeometryTools;
import sos.fire_v2.decision.FireInformationModel;
import sos.search_v2.tools.cluster.ClusterData;

public class Weight {

	FireInformationModel infoModel;
	public ArrayList<Building> Buildings = new ArrayList<Building>();
	ArrayList<Float> distance = new ArrayList<Float>();
	Vector<Building> CheckedEstimate = new Vector<Building>();
	//max
	float maxNeighbour = -1;
	float maxTemperature = -1;
	float maxCenterDistance = -1;
	float maxArea = -1;
	float maxGassStationDistance = -1;

	public Weight(FireInformationModel f) {

		infoModel = f;

	}

	public void setBuildings(ArrayList<Building> b) {
		Buildings = new ArrayList<Building>();
		//	infoModel.Saba_Log.warn("Weight: Number of buildings before being set that are being weighted is: " + Buildings.size());
		Buildings.addAll(b);
		//	infoModel.Saba_Log.warn("Weight: Number of buildings after being set that are being weighted is: " + Buildings.size());
		infoModel.Saba_Log.info("**************3 " + Buildings.size());
	}

	public void Infos() {

		ArrayList<ClusterData> clusters = new ArrayList<ClusterData>(infoModel.getAgent().model().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new DistanceComparator(infoModel.getAgent()));
		Buildings.addAll(infoModel.getMyCluster().getBuildings());

	}

	public void calculateMax() {
		maxTemperature = -1;
		maxNeighbour = -1;
		maxCenterDistance = -1;
		maxArea = -1;
		for (Building b : Buildings) {
			infoModel.Saba_Log.info("in calculate max(in for)");
			if (b.getTemperature() > maxTemperature)
				maxTemperature = b.getTemperature();
			if (b.getNeighbour_counter() > maxNeighbour)
				maxNeighbour = b.getNeighbour_counter();
			if (b.getTotalArea() > maxArea)
				maxArea = b.getTotalArea();
			float d = SOSGeometryTools.getDistance(b.getPositionPoint(), new Point2D(infoModel.getModel().mapCenter().getX(), infoModel.getModel().mapCenter().getY()));
			if (d > maxCenterDistance)
				maxCenterDistance = d;

			distance.add(getGassStationDistance(b));
		}
		infoModel.Saba_Log.info(" max Temp = " + maxTemperature);
		infoModel.Saba_Log.info(" max neighbour = " + maxNeighbour);
		infoModel.Saba_Log.info(" max centerDistance = " + maxCenterDistance);
		infoModel.Saba_Log.info(" max Area = " + maxArea);
	}

	private float getGassStationDistance(Building b) {

		ArrayList<Building> gasses = new ArrayList<Building>();

		for (Building n : b.realNeighbors_Building()) {

			for (Building nn : n.realNeighbors_Building()) {
				if (!(nn instanceof GasStation))
					continue;
				if (gasses.contains(nn))
					continue;
				gasses.add(nn);
			}
		}

		if (gasses.isEmpty())
			return -1;

		float avg = 0;
		for (Building g : gasses) {
			avg += SOSGeometryTools.distance(g.getAreaPosition(), b.getAreaPosition());
		}
		avg = avg / gasses.size();
		if (avg > maxGassStationDistance)
			maxGassStationDistance = avg;
		return avg;
	}

	public void setBuildingWeight() {

		for (Building b : Buildings) {
			float weight = 0f;
			if (b instanceof GasStation && b.getFieryness() == 0)
			{
				b.setWeight(10000);
				continue;
			}
			if (b instanceof Refuge) {
				b.setWeight(-1111111);
				continue;
			}
			int index = Buildings.indexOf(b);
			infoModel.Saba_Log.info("######## " + b.getID() + "#######");
			if (b.getFieryness() > 0 && b.getFieryness() < 4 && b.getTotalArea() < 500)
				weight = (b.getTotalArea() / maxArea);
			//TODO total area bishtar az 1000 o nabayad khamoosh kone?
			else
				weight = 1 - (b.getTotalArea() / maxArea);
			infoModel.Saba_Log.info(" area  = " + b.getTotalArea() + " w= " + weight);
			weight += 1 - (SOSGeometryTools.getDistance(b.getPositionPoint(), new Point2D(infoModel.getModel().mapCenter().getX(), infoModel.getModel().mapCenter().getY())) / maxCenterDistance);
			infoModel.Saba_Log.info("centerdistance = " + SOSGeometryTools.getDistance(b.getPositionPoint(), new Point2D(infoModel.getModel().mapCenter().getX(), infoModel.getModel().mapCenter().getY())) + "w=" + weight);
			if (b.getTemperature() > 400 && b.getFieryness() ==3)
				weight += (1 - (b.getTemperature() / maxTemperature));
			else
				weight += (1 - (b.getTemperature() / maxTemperature))*2;
			infoModel.Saba_Log.info(" temp  = " + b.getTemperature() + " w= " + weight);
			if (b.getFieryness() > 0 && b.getFieryness() < 4)
				weight += 4 * (b.getNeighbour_counter() / maxNeighbour);
			else
				weight += (b.getNeighbour_counter() / maxNeighbour);
			infoModel.Saba_Log.info(" neighbour  = " + b.getNeighbour_counter() + " w= " + weight);
			if (distance.get(index) != -1) {
				weight += (1 - (distance.get(index) / maxGassStationDistance)) * 3;
				infoModel.Saba_Log.info(" gass dis= " + weight);
			}

			switch (b.getFieryness()) {
			case 0:
				if(!(b instanceof GasStation))
				b.setWeight(-1000); //5
				break;
			case 1:
				b.setWeight(weight +2); //6
				break;
			case 2:
				b.setWeight(weight +1.25f); //4
				break;
			case 3:
				b.setWeight(weight +0.5f); //3
				break;
			case 4:
				b.setWeight(-1000); //0
				break;
			case 5:
				b.setWeight(-10000); //1
				break;
			case 6:
				b.setWeight(-10000); //2
				break;

			case 8:
				b.setWeight(-1111111111);
				infoModel.Saba_Log.info("weight###### case: 8");
				break;
			}
			infoModel.Saba_Log.info(" fireyness  = " + b.getFieryness() + " w= " + weight);

			infoModel.Saba_Log.info(" building weight = " + b.getWeight());
			infoModel.Saba_Log.info("######################");
		}

	}

	//public void HighTemp() {

	//	for (Building b : Buildings) {
	//infoModel.Saba_Log.info(" id " + b.getID() + " bw = " + b.getWeight());
	//		if (b.getTemperature() <= 200)
	//			b.setWeight(b.getWeight() + 1100);

	//		else if (b.getTemperature() > 200 && b.getTemperature() <= 500)
	//			b.setWeight(b.getWeight() + 1000);

	//		else if (b.getTemperature() > 500)
	//			b.setWeight(b.getWeight() + 50);

	//infoModel.Saba_Log.info(" id " + b.getID() + " aw = " + b.getWeight());

	//	}

	//public void FireyNess() {

	//************************Change Numbers******************\\

	// 0-> khamoosh
	// 1-> taze roshan shode
	// 2-> atishe motevaset
	// 3-> atishe shadid
	// 4-> atishe noe 1 khamoosh shode
	// 5-> atishe noe 2 khamoosh shode
	// 6-> atishe noe 3 khamoosh shode
	// 7-> sookhte
	// 8-> sakhtemooni k asan atish nagerefte vali ma roosh ab rikhtim

	//	for (Building b : Buildings)

	//		switch (b.getFieryness()) {

	//		case 0:
	//		b.setWeight(b.getWeight() * 8);
	//		break;
	//	case 1:
	//	b.setWeight(b.getWeight() * 15);
	//	break;
	//case 2:
	//	b.setWeight(b.getWeight() * 7);
	//	break;
	//case 3:
	//	b.setWeight(b.getWeight() * 6);
	//		break;
	//case 4:
	//	b.setWeight(b.getWeight() + 100);
	//	break;
	//	case 5:
	//	b.setWeight(b.getWeight() + 120);
	//	break;
	//	case 6:
	//b.setWeight(b.getWeight() + 130);
	//	break;

	//	case 8:
	//	b.setWeight(1);
	//	break;
	//	}
	//	}

	//	public void DecreaseMyClusterWeight() {

	//	for (Building b : Buildings) {

	//	if (infoModel.getMyCluster().getBuildings().contains(b))
	//	b.setWeight(b.getWeight() * 20);

	//	}

	//	}

	//public void Area() {

	/////***** CHANGES: are for when the area is not that much, extinguishing the own building not its neighbours******\\\\\	
	//for (Building b : Buildings) {

	//	if (b.getTotalArea() < 50)
	//	b.setWeight(b.getWeight() + 50);
	//	else if (b.getTotalArea() > 50 && b.getTotalArea() < 100)
	//		b.setWeight(b.getWeight() * 3);
	//	else if (b.getTotalArea() > 100 && b.getTotalArea() < 200) {

	//					for (sos.base.entities.Area n : b.realNeighbors_Building()) {
	//						if (!(n instanceof Building))
	//							continue;
	//
	//						((Building) n).setWeight(((Building) n).getWeight() * 5);
	//
	//						b.setWeight(b.getWeight() / 1.2f);
	//					}

	//	b.setWeight(b.getWeight() * 4);

	//	}
	//	else if (b.getTotalArea() > 200 && b.getTotalArea() < 1000)
	//	b.setWeight(b.getWeight() * 5);

	//	else
	//	b.setWeight(b.getWeight() + 100);

	//	}
	//	}

	//	public void Neighbours() {

	//	for (Building b : Buildings) {
	//			if (b.getNeighbour_counter() > 7)
	//		b.setWeight(b.getWeight() + 7000);
	//	else if (b.getNeighbour_counter() > 4 && b.getNeighbour_counter() < 7)
	//	b.setWeight(b.getWeight() + 5000);
	//	}

	//}

	//	public void saveGasStation() {

	//		for (Building b : Buildings) {

	//		if (b instanceof GasStation)
	//		for (Building nb : b.realNeighbors_Building()) {
	//	if (nb.getFieryness() == 0)
	//		nb.setWeight(nb.getWeight() * 10);

	//	}

	//	}

	//	}

	//	public void IgnitionTrue() {
	//
	//		for (Building b : Buildings) {
	//			if(!b.isIgnitionDefined())
	//				continue;
	//			if (b.getIgnition())
	//				b.setWeight(b.getWeight() * 8.2f);
	//
	//		}	
	//		
	//		
	//		
	//		
	//	}

	//	public void Estimate(Building b) {

	//	for (Area a : b.realNeighbors_Building()) {

	//	Vector<Area> RoadsNeighbours = new Vector<Area>();
	//	if (a instanceof Road) {
	//		infoModel.Saba_Log.info("SFirezone: Adding neighbours of the road to the firezone. ");
	//		RoadsNeighbours.addAll(b.realNeighbors_Building());
	//	for (Area a2 : RoadsNeighbours) {
	//		if (!(a2 instanceof Building))
	//			continue;

	//	Building b3 = (Building) a2;

	//		if (infoModel.self().isValid(b3))
	//			continue;
	//		if (CheckedEstimate.contains(b3))
	//		continue;
	//	CheckedEstimate.add(b3);
	//	Estimate(b3);

	//	}

	//	}

	//	if (!(a instanceof Building))
	//		continue;
	//	if (((Building) a).getFieryness() > 0 && ((Building) a).getFieryness() < 4)
	//		continue;
	//	if (CheckedEstimate.contains(b))
	//		continue;
	//	CheckedEstimate.add((Building) a);
	//	Estimate((Building) a);
	//	}

	//	}

	//public void WeightEstimate() {

	//	Collections.sort(Buildings, new Comparator<Building>() {

	//	@Override
	//	public int compare(Building b1, Building b2) {
	//		if (b1.BuildingEstimate > b2.BuildingEstimate)
	//		return 1;
	//	else if (b1.BuildingEstimate < b2.BuildingEstimate)
	//	return -1;
	//	return 0;
	//	}
	//	});

	//	for (int i = 0; Buildings.size() > i; i++) {

	//	Buildings.get(i).setWeight(Buildings.get(i).getWeight() + (10 * (i + 2)));

	//	}

	//	}

	//	public void printWeight(){
	//	for(Building b: Buildings)
	//		infoModel.Saba_Log.info("Building " + b.getID() + " weight is: " + b.getWeight() );

	//	}

	public void resetWeights() {
		infoModel.Saba_Log.info("Weight: ResetWeights was called. Buildings size is: " + Buildings.size());
		for (Building b : Buildings)
			b.setWeight(0);
	}

	
	public void setWeights(ArrayList<Building> buildings) {
		infoModel.Saba_Log.info("**************2   " + buildings.size());
		setBuildings(buildings);
		resetWeights();
		calculateMax();
		setBuildingWeight();
		infoModel.Saba_Log.info(" SIZE= " + buildings.size());
		for (Building b : buildings) {
			infoModel.Saba_Log.info("num.: " + buildings.indexOf(b) + " F: " + b.getFieryness() + " tp: " + b.getTemperature() + "ta" + b.getTotalArea());
		}
	}
}