package sos.fire_v2.Saba_States;

import java.util.ArrayList;
import java.util.List;

import sos.base.entities.Building;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.fire_v2.decision.FireInformationModel;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

/////DONE
public class searchZone extends SOSIState<FireInformationModel> {

	public searchZone(FireInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {

		if (infoModel.getFireAgent().SearchfireZoneSide != null) {
			for(Building b:infoModel.getFireAgent().SearchfireZoneSide)
				if(infoModel.getFireAgent().isValid(b)){
					infoModel.Saba_Log.info("SearchZone: There was a firey buildings there so stop searching and skip searchZone. ");
					return null;
					}
			isAllCheckedSearchfireZoneSide();
			infoModel.Saba_Log.info("SearchZone: Check if all buildings are searched.");
			if (infoModel.getFireAgent().SearchfireZoneSide == null){
				infoModel.Saba_Log.info("SearchZone: All buildings were searched so skip searchZone. ");
				return null;
			}
			infoModel.Saba_Log.info("SearchZone: Task is SabaSearchSideTask. ^_^ ");
			return new SabaSearchSideTask(null,infoModel.self().SearchfireZoneSide, infoModel.getTime(), infoModel);
		}

		if (infoModel.getFireAgent().ThereWasFireInMyCluster && infoModel.self().last_task != LastTask.SabaSearchTask 
				&& infoModel.self().lastZone!= null)
		{
			infoModel.getFireAgent().SearchfireZoneSide = new ArrayList<Building>();
			infoModel.self().SearchfireZoneSide.addAll(infoModel.self().lastZone.FireZoneNeighbours);
			infoModel.Saba_Log.info("searchZone: Start search on firezone buildings' side");
			return new SabaSearchSideTask(null,infoModel.self().SearchfireZoneSide, infoModel.getTime(), infoModel);
		}

		
		return null;
	}

	private void isAllCheckedSearchfireZoneSide() {

		for (Building b : infoModel.getFireAgent().SearchfireZoneSide)
		{
			if (b == null)
				continue;
			if (b.getChecked())
				continue;
			return;
		}

		infoModel.getFireAgent().SearchfireZoneSide = null;
		infoModel.self().lastZone=null;
		infoModel.getFireAgent().ThereWasFireInMyCluster=false;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
