package sos.fire_v2.decision;

import sos.base.SOSAgent;
import sos.base.entities.Human;
import sos.fire_v2.Saba_States.Buriedness;
import sos.fire_v2.Saba_States.Dead;
import sos.fire_v2.Saba_States.Extinguish;
import sos.fire_v2.Saba_States.HighHP_FullWater;
import sos.fire_v2.Saba_States.HighHP_LowWater;
import sos.fire_v2.Saba_States.IAmHurtState;
import sos.fire_v2.Saba_States.Interrupt;
import sos.fire_v2.Saba_States.LowHP_FullWater;
import sos.fire_v2.Saba_States.LowHP_LowWater;
import sos.fire_v2.Saba_States.LowWater_CloseToRefuge;
import sos.fire_v2.Saba_States.No_Water;
import sos.fire_v2.Saba_States.Stuck;
import sos.fire_v2.Saba_States.searchIntrrupt;
import sos.fire_v2.Saba_States.searchZone;
import sos.tools.decisionMaker.implementations.stateBased.SOSStateBasedDecisionMaker;
import sos.tools.decisionMaker.implementations.stateBased.StateFeedbackFactory;

public class FireDecisionMaker extends SOSStateBasedDecisionMaker<FireInformationModel> {

	public String lastState = "Null";
	public String lastAct = "Null";

	public FireDecisionMaker(SOSAgent<? extends Human> agent, StateFeedbackFactory feedbackFactory) {
		super(agent, feedbackFactory, FireInformationModel.class);
	}

	@Override
	public void initiateStates() {
		
		getThinkStates().add(new Dead(getInfoModel()));
		getThinkStates().add(new Buriedness(getInfoModel()));
		getThinkStates().add(new Stuck(getInfoModel()));
		getThinkStates().add(new No_Water(getInfoModel()));
		getThinkStates().add(new IAmHurtState(getInfoModel()));
		getThinkStates().add(new Interrupt(getInfoModel()));
		getThinkStates().add(new Extinguish(getInfoModel()));
		getThinkStates().add(new searchIntrrupt(getInfoModel()));			
		getThinkStates().add(new searchZone(getInfoModel()));		
		getThinkStates().add(new HighHP_FullWater(getInfoModel()));              
		getThinkStates().add(new LowHP_FullWater(getInfoModel()));
		getThinkStates().add(new LowWater_CloseToRefuge(getInfoModel()));
		getThinkStates().add(new LowHP_LowWater(getInfoModel()));
		getThinkStates().add(new HighHP_LowWater(getInfoModel()));
		
		
		
	}

	public FireInformationModel getInfoModel() {
		return infoModel;
	}

}
