package sos.police_v2.SSTask;


import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import sos.base.SOSAgent;
import sos.base.entities.Area;
import sos.base.entities.Blockade;
import sos.base.entities.Human;
import sos.base.entities.Road;
import sos.base.move.Path;
import sos.base.move.types.PoliceMove;
import sos.base.util.SOSActionException;
import sos.base.util.geom.ShapeInArea;
import sos.police_v2.PoliceConstants;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.clearableBlockadeToReachable.GeoPathReachablity;
import sos.police_v2.clearableBlockadeToReachable.ReachablingUsingReachablityTool;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSITarget;
import sos.tools.decisionMaker.definitions.commands.SOSTask;

public class Move_path extends SOSTask<SOSITarget>{

	GeoPathReachablity reachableWithEdge;
	ReachablingUsingReachablityTool reachablityTool;
	
	public Move_path(Path target, ShapeInArea postition, int creatinTime) {
		super(new PathTarget(target, postition), creatinTime);
	}

	@Override
	public BlockadeTarget getTarget() {
		return (BlockadeTarget) target;
	}

	@Override
	public void execute(SOSAgent<? extends Human> agent) throws SOSActionException {
		Path path = ((PathTarget) target).getTarget();
		if (path == null) {
	//
			Road randomDST = agent.model().roads().get((int) (Math.random() * (agent.model().roads().size() - 1)));
			ArrayList<Area> area = new ArrayList<Area>();
			area.add(randomDST);
			 path = agent.move.getPathTo(area, PoliceMove.class);
				((PoliceForceAgent) agent).move(path);
		}
		justMakeReachable(path,(PoliceForceAgent)agent);
		((PoliceForceAgent) agent).move(path);
	}


	private void justMakeReachable(Path path,PoliceForceAgent agent) throws SOSActionException {
		reachablityTool = new ReachablingUsingReachablityTool(agent);
		reachableWithEdge = new GeoPathReachablity(agent);
		if (!PoliceConstants.IS_NEW_CLEAR) {

			ArrayList<Blockade> blocks = new ArrayList<Blockade>();

			ArrayList<Blockade> blockadeEdge = reachableWithEdge.getBlockingBlockadeOfPath(path);
			blocks.addAll(blockadeEdge);
			//
			if (blocks.isEmpty()) {
				blocks.addAll(reachablityTool.getBlockingBlockadeOfPath(path));
				//	ArrayList<Blockade> blockadeEdge = clearableBlockadeToFullReachable.getBlockingBlockadeOfPath(path);
			}

			Blockade clearBlock = chooseBestBlockade(blocks,agent);

			if (clearBlock != null)
				agent.clear(clearBlock);
		} else {
			Point next = agent.degreeClearableToPoint.nextPointToClear(path, true, true);
			if (next != null) {
				//				log.warn("clear at" + next);
				agent.clear(next);
			}
		}
	}


	 Blockade chooseBestBlockade(List<Blockade> list,PoliceForceAgent agent) {
		if (list == null) {
			return null;
		}
		Blockade best = null;
		double bestValue = 0;
		for (Blockade blockade : list) {
			if (SSUtils.isValid(blockade)) {
				int value = (int) (1000000 / Math.max(agent.me().getPositionPoint().distance(blockade.getCenteroid()), 1));
				if (value > bestValue) {
					bestValue = value;
					best = blockade;
				}
			}
		}
		return best;
	}

}
