package sos.police_v2.SSstate;

import java.awt.Point;
import java.util.List;

import sos.base.entities.Area;
import sos.base.entities.Blockade;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.base.util.information_stacker.act.AbstractAction;
import sos.base.util.information_stacker.act.ClearAction;
import sos.police_v2.PoliceConstants;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.SSTask.ClearPoint;
import sos.police_v2.decision.PoliceInformationModel;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class Entrances extends SOSIState<PoliceInformationModel>{

	Area blockArea = null;
	public Entrances(PoliceInformationModel infoModel) {
		super(infoModel);

	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		if(PoliceConstants.IS_NEW_CLEAR)
			return null;
		infoModel.getLog().info("//EntrancesState\\");
		
		AbstractAction lastAct = infoModel.getAgent().informationStacker.getInformations(1).getAct();
		if (lastAct instanceof ClearAction) {
			Area area = ((ClearAction) lastAct).getBlockade().getAreaPosition();
			if (area instanceof Road && SSUtils.isEntrance(area) && area.getBlockades().size() > 0) {
				blockArea = area;
				Blockade best = SSUtils.chooseBestBlockade(blockArea.getBlockades(),(PoliceForceAgent)infoModel.getAgent());
				if (best != null)
				{
					infoModel.getLog().info("clear point task to" + new Point(best.getX(), best.getY()));
					return new ClearPoint(new Point(best.getX(), best.getY()), null, infoModel.getTime());}

			}
		}
		return null;
	}

	

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
