package sos.police_v2.SSstate;

import java.awt.geom.Point2D;
import java.util.List;

import sos.base.entities.Blockade;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.police_v2.SSTask.ClearBlockade;
import sos.police_v2.decision.PoliceInformationModel;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class InClosedRoad extends SOSIState<PoliceInformationModel> {

	public InClosedRoad(PoliceInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}



	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		infoModel.getLog().info("//POlice CloseRoadState\\");
		if (infoModel.getTime() < 4){
			infoModel.getLog().info("time < 4");
			return null;
		}
		
		if (!(infoModel.getAreaPosition() instanceof Road)){
			infoModel.getLog().info("police is not in road");
			return null;
		}
		
		infoModel.setLastTarget(null);
		for (Blockade blockade : infoModel.getPolice().getAreaPosition().getBlockades()) {
			infoModel.getLog().info("in for!! " );
			if (!SSUtils.isValid(blockade)){
				infoModel.getLog().info("blockade was not valid");
				continue;
			}
			
			if (blockade.getShape().contains(new Point2D.Double(infoModel.getPolice().getX(), infoModel.getPolice().getY()))) {
				infoModel.getLog().info("blockade"+ blockade +"was valid." );
				infoModel.setLastTarget(blockade);
				if (infoModel.getLastTarget() != null)
				{
					infoModel.getLog().info("new clearBlockade:" + infoModel.getLastTarget().getID());
					return new ClearBlockade(infoModel.getLastTarget(), null, infoModel.getTime());
			
				}
				}
		}

		return null;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data,
			SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
