package sos.police_v2.SSstate;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.base.entities.Area;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.move.Path;
import sos.base.move.types.PoliceMove;
import sos.police_v2.SSTask.Move_path;
import sos.police_v2.decision.PoliceInformationModel;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class OpenCivilian extends SOSIState<PoliceInformationModel> {

	public OpenCivilian(PoliceInformationModel infoModel) {
		super(infoModel);
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) {
		
		infoModel.getLog().info("// OPenCIvilian \\");
		
		if (infoModel.self().assignCivil != null && SSUtils.missionComplete(infoModel.self().assignCivil,infoModel.self())) {
			infoModel.self().assignCivil.setIsReallyReachable(true);
			infoModel.self().assignCivil = null;
			infoModel.getLog().info("assign civ is null");
		}
		if (!SSUtils.isValidCivilian(infoModel.self().assignCivil, infoModel.self())) {
			infoModel.self().assignCivil = SSUtils.assignNewCivilian(infoModel.self());
			infoModel.getLog().info("assigned civil is not valid");
		}
		if (infoModel.self().assignCivil != null) {
			infoModel.getLog().info("assigned civil != null");
			Pair<Area, Point2D> ep = SSUtils.getEntrancePoint(infoModel.self().assignCivil.getAreaPosition(),infoModel.self());
			if (ep == null) {
				infoModel.self().assignCivil = null;
				infoModel.getLog().info("entrance point was null");
				return null;
			}
			ArrayList<Pair<? extends Area, Point2D>> dests = new ArrayList<Pair<? extends Area, Point2D>>();
			dests.add(ep);
			if (dests.isEmpty())
			{
				Road randomDST = infoModel.getModel().roads().get((int) (Math.random() * (infoModel.getModel().roads().size() - 1)));
				ArrayList<Area> area = new ArrayList<Area>();
				area.add(randomDST);
				Path path = infoModel.self().move.getPathTo(area, PoliceMove.class);
				infoModel.getLog().info("new movepath" + path.getDestination());
				return new Move_path(path, null, infoModel.getTime());
			}

			Path path = infoModel.getAgent().move.getPathToPoints(dests, PoliceMove.class);
			infoModel.getLog().info("new movepath " + path.getDestination());
			return new Move_path(path, null, infoModel.getTime());
		}

		return null;
	}


	@Override
	public void giveFeedbacks(List feedbacks) {
	}

	@Override
	public void skipped() {
	}

	@Override
	public void overTaken() {
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
	}

	@Override
	public String getName() {
		return "ImHurtState";
	}

	@Override
	public void taken() {
		super.taken();
	}
}
