package sos.police_v2.SSstate;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.base.entities.Area;
import sos.base.entities.Blockade;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.MessageXmlConstant;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.SSTask.ClearBlockade;
import sos.police_v2.decision.PoliceInformationModel;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class OpenStuckAgent extends SOSIState<PoliceInformationModel>{

	public ArrayList<Area> stockPositions = new ArrayList<Area>();
	public HashSet<Area> checkedArea = new HashSet<Area>();
	public OpenStuckAgent(PoliceInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		// TODO Auto-generated method stub
		infoModel.getLog().info("//open stuck agent\\");
		for (Area stock : stockPositions) {
			if (checkedArea.contains(stock))
				continue;
			if (!((PoliceForceAgent)infoModel.getAgent()).myClusterShape.contains(stock.getPositionPoint().toGeomPoint()))
				continue;
			if (stock.equals(infoModel.getPolice().getAreaPosition())) {
				if (stock.isBlockadesDefined()) {

					for (Blockade block : stock.getBlockades()) {
						if (SSUtils.isValid(block))
							new ClearBlockade(block, null, infoModel.getTime());
					}
					for (Blockade block : stock.getBlockades()) {
						ArrayList<Pair<? extends Area, Point2D>> dests = new ArrayList<Pair<? extends Area, Point2D>>();
						dests.add(block.getPositionPair());
						infoModel.getLog().info("move to point" + dests);
						return SSUtils.moveToPoint(dests,infoModel);

					}
				}

				checkedArea.add(stock);
			} 
			else {
				ArrayList<Pair<? extends Area, Point2D>> dests = new ArrayList<Pair<? extends Area, Point2D>>();
				dests.add(stock.getPositionPair());
				infoModel.getLog().info("move to point 2" + dests);
				return SSUtils.moveToPoint(dests,infoModel);
				
			}
			}
		return null;
	
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub
		if (header.equalsIgnoreCase(MessageXmlConstant.HEADER_AGENT_STOCK)) {
			Area area = infoModel.getModel().areas().get(data.get(MessageXmlConstant.DATA_AREA_INDEX));
			if (!infoModel.getAgent().getMyClusterData().isCoverer())
				stockPositions.add(area);
		}
		
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
