package sos.police_v2.SSstate;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.base.entities.Area;
import sos.base.entities.Civilian;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.move.Path;
import sos.base.move.types.PoliceMove;
import sos.base.util.SOSActionException;
import sos.police_v2.SSTask.Move_path;
import sos.police_v2.decision.PoliceInformationModel;
import sos.police_v2.decision.SSUtils;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class OpenWithOutBurridnessCivilian extends SOSIState<PoliceInformationModel> {

	public OpenWithOutBurridnessCivilian(PoliceInformationModel infoModel) {
		super(infoModel);
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		
		
		if (infoModel.self().assignCivil != null && SSUtils.missionComplete(infoModel.self())) {
			infoModel.self().assignCivil.setIsReallyReachable(true);
			infoModel.self().assignCivil = null;
		}

		if (!SSUtils.isValidHealtyCivilian(infoModel.self().assignCivil, infoModel.self())) {
			if (infoModel.self().assignCivil != null)
				infoModel.self().assignCivil = assignNewCivilian();
		}
		
		
		if (infoModel.self().assignCivil != null) {
			Pair<Area, Point2D> ep = SSUtils.getEntrancePoint(infoModel.self().assignCivil.getAreaPosition(), infoModel.self());
			if (ep == null) {
				infoModel.self().assignCivil = null;
				return null;
			}
			
		infoModel.getLog().info("// Open withoutBur state \\");
			ArrayList<Pair<? extends Area, Point2D>> dests = new ArrayList<Pair<? extends Area, Point2D>>();
			dests.add(ep);
			if (dests.isEmpty())
			{
				Road randomDST = infoModel.getModel().roads().get((int) (Math.random() * (infoModel.getModel().roads().size() - 1)));
				ArrayList<Area> area = new ArrayList<Area>();
				area.add(randomDST);
				Path path = infoModel.self().move.getPathTo(area, PoliceMove.class);
				infoModel.getLog().info("move path task" + path.getDestination());
				return new Move_path(path, null, infoModel.getTime());
			}

			Path path = infoModel.getAgent().move.getPathToPoints(dests, PoliceMove.class);
			infoModel.getLog().info("move path task" + path.getDestination());
			return new Move_path(path, null, infoModel.getTime());
		}

		return null;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	private Civilian assignNewCivilian() {
		infoModel.getLog().info("assing new civ function");
		ArrayList<Civilian> civis = new ArrayList<Civilian>();

		for (Civilian civilian : infoModel.getModel().civilians()) {
			if (SSUtils.isValidCivilian(civilian, infoModel.self()))
				if (infoModel.getMyCluster().getBuildings().contains(civilian.getAreaPosition()))
					civis.add(civilian);

		}
		if (civis.size() > 0) {
			Civilian target = civis.get(0);
			for (Civilian civilian : civis) {
				if (target == civilian){
					infoModel.getLog().info("target == civilian");
					continue;
				}
				if (Point.distance(infoModel.getPolice().getX(), infoModel.getPolice().getY(), civilian.getX(), civilian.getY())
				< Point.distance(infoModel.getPolice().getX(), infoModel.getPolice().getY(), target.getX(), target.getY())) {
					target = civilian;
				}
			}
			return target;
		}

		return null;
	}
}
