package sos.police_v2.SSstate;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import sos.base.entities.Building;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.SSTask.Search_task;
import sos.police_v2.decision.PoliceInformationModel;
import sos.search_v2.tools.SearchTask;
import sos.search_v2.worldModel.SearchBuilding;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;

public class ProbableFires extends SOSIState<PoliceInformationModel> {

	public ProbableFires(PoliceInformationModel infoModel) {
		super(infoModel);
		checkRang = (int) (infoModel.getModel().getDiagonalOfMap() / 5);
	}

	private ArrayList<Building> fireList;
	private ArrayList<Building> nearFireList;
	private Road lastTarget = null;
	private int checkRang = 0;
	

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		
		if (infoModel.getModel().time() > infoModel.getLastLock() + 20)
			infoModel.setLastLock(0);
		if (infoModel.getModel().time() < infoModel.getLastLock() + 50)
			return null;
		if (((PoliceForceAgent)infoModel.getAgent()).preIsDone)
			return null;
		fireList = infoModel.getAgent().fireProbabilityChecker.getProbabilisticFieryBuilding();
		if (fireList.size() == 0) {
			return null;
		}
		infoModel.getLog().info("//ProbableFires State\\");
		if (lastTarget != null)
			return work();
		
		
		//		setTarget();
		nearFireList = new ArrayList<Building>();
		for (Building select : fireList) {
			if (Point.distance(select.x(), select.y(), infoModel.getPolice().getX(), infoModel.getPolice().getY()) <= checkRang) {
				nearFireList.add(select);
			}
		}
		if (nearFireList.size() > 0)
			return work();
		return null;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public SOSTask<?> work(){
		infoModel.getLog().info("in work function");
		infoModel.setSpentTime(infoModel.getSpentTime()+ 1);
		if (infoModel.getSpentTime() > 10) {
			infoModel.getLog().info("spent time > 10");
			infoModel.setLastLock(infoModel.getModel().time());
			infoModel.setSpentTime(0);
			lastTarget = null;
			return null;
		}
		if (nearFireList.isEmpty())
			return null;

		SearchBuilding best = infoModel.getAgent().newSearch.getSearchWorld().getSearchBuilding(nearFireList.get(0));

		for (Building b : nearFireList) {
			SearchBuilding sb = infoModel.getAgent().newSearch.getSearchWorld().getSearchBuilding(b);
			if (sb.isSpecialForFire() > best.isSpecialForFire())
				best = sb;
		}
		SearchTask task = new SearchTask(best.getRealBuilding().fireSearchBuilding().sensibleAreasOfAreas());
		if (task == null) {
			return null;
		} 
		else {
			infoModel.getLog().info("searchtask to" + task.getArea());
			return new Search_task(task, null, infoModel.getTime());
		}
	
	}
}
