package sos.police_v2.SSstate;

import java.util.ArrayList;
import java.util.List;

import sos.base.entities.GasStation;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.message.structure.SOSBitArray;
import sos.base.message.structure.blocks.DataArrayList;
import sos.base.message.structure.channel.Channel;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.police_v2.decision.PoliceInformationModel;
import sos.tools.decisionMaker.definitions.commands.SOSTask;
import sos.tools.decisionMaker.definitions.feedback.SOSFeedback;
import sos.tools.decisionMaker.implementations.stateBased.SOSEventPool;
import sos.tools.decisionMaker.implementations.stateBased.events.SOSEvent;
import sos.tools.decisionMaker.implementations.stateBased.states.SOSIState;
import sos.tools.decisionMaker.implementations.targets.AreaTarget;
import sos.tools.decisionMaker.implementations.tasks.StandardMoveToAreaTask;

public class RunAwayFromGasStationState extends SOSIState<PoliceInformationModel> {

	public RunAwayFromGasStationState(PoliceInformationModel infoModel) {
		super(infoModel);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SOSTask<?> decide(SOSEventPool eventPool) throws SOSActionException {
		// TODO Auto-generated method stub	
		infoModel.getLog().info("//ImNearGasStation State\\");
		for (GasStation gasStation : infoModel.getModel().GasStations()) {
			if (SOSGeometryTools.distance(gasStation, infoModel.getPolice().getAreaPosition()) < 5000 && gasStation.getTemperature() > 35 && (gasStation.getFieryness() == 0 || gasStation.getFieryness() == 4)) {
				ArrayList<Road> Roads = new ArrayList<Road>();
				if (infoModel.getLastTarget() != null)
					infoModel.setLastTarget(null);
				for (Road Road : Roads)
					if (SOSGeometryTools.distance(Road.getAreaPosition(), gasStation.getAreaPosition()) > 5500){
						infoModel.getLog().info("move task to" + new AreaTarget(Road.getAreaPosition()));
						return new StandardMoveToAreaTask(new AreaTarget(Road.getAreaPosition()), infoModel.getTime());
						}
			}
		}
		return null;
	}

	@Override
	public void giveFeedbacks(List<SOSFeedback> feedbacks) {
		// TODO Auto-generated method stub

	}

	@Override
	public void skipped() {
		// TODO Auto-generated method stub

	}

	@Override
	public void overTaken() {
		// TODO Auto-generated method stub

	}

	@Override
	protected void handleEvent(SOSEvent sosEvent) {
		// TODO Auto-generated method stub

	}

	@Override
	public void hear(String header, DataArrayList data, SOSBitArray dynamicBitArray, StandardEntity sender, Channel channel) {
		// TODO Auto-generated method stub

	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

}
