package sos.police_v2.decision;

import sos.police_v2.PoliceForceAgent;
import sos.police_v2.SSstate.CivilianOpening;
import sos.police_v2.SSstate.CloseAgents;
import sos.police_v2.SSstate.IHaveBurridness;
import sos.police_v2.SSstate.ImDead;
import sos.police_v2.SSstate.InClosedRoad;
import sos.police_v2.SSstate.OpeningAgent;
import sos.police_v2.SSstate.ReallyStuck;
import sos.police_v2.SSstate.RunAwayFromGasStationState;
import sos.police_v2.SSstate.Stuck;
import sos.tools.decisionMaker.implementations.stateBased.SOSStateBasedDecisionMaker;
import sos.tools.decisionMaker.implementations.stateBased.StateFeedbackFactory;

public class PoliceDecisionMaker extends SOSStateBasedDecisionMaker {

	private final PoliceForceAgent agent;

	public PoliceDecisionMaker(PoliceForceAgent agent, StateFeedbackFactory feedbackFactory) {
		super(agent, feedbackFactory, PoliceInformationModel.class);
		this.agent = agent;
	}

	@Override
	public void initiateStates() {
		getThinkStates().add(new ImDead(getInfoModel()));
		getThinkStates().add(new IHaveBurridness(getInfoModel()));
		getThinkStates().add(new InClosedRoad(getInfoModel()));
		getThinkStates().add(new Stuck(getInfoModel()));
		getThinkStates().add(new ReallyStuck(getInfoModel()));
		getThinkStates().add(new RunAwayFromGasStationState(getInfoModel()));
		getThinkStates().add(new CloseAgents(getInfoModel()));
		getThinkStates().add(new CivilianOpening(getInfoModel()));
		//TODO
		// till CiviReachableState of Police v3
		
		// getThinkStates().add(new ProbableFires(getInfoModel()));
		getThinkStates().add(new OpeningAgent(getInfoModel()));
		// getThinkStates().add(new Entrances(getInfoModel()));
		//TODO
		//	dont forget nocom and aftershock
		//TODO
		// MSTSTATE

		// getThinkStates().add(new Precompute(getInfoModel()));
		// getThinkStates().add(new OpenWithOutBurridnessCivilian(getInfoModel()));
		//TODO
		// firy zune should be finished 
		// getThinkStates().add(new fireSide(getInfoModel()));
		// getThinkStates().add(new HelpFire(getInfoModel()));
		// getThinkStates().add(new OpenStuckAgent(getInfoModel()));
		// getThinkStates().add(new OpenCivilian(getInfoModel()));
		//TODO
		// search task

	}

	public PoliceInformationModel getInfoModel() {
		return (PoliceInformationModel) infoModel;
	}
}