package sos.police_v2.decision;

import sos.base.SOSAgent;
import sos.base.entities.Area;
import sos.base.entities.Blockade;
import sos.base.entities.Human;
import sos.base.entities.PoliceForce;
import sos.base.entities.StandardEntity;
import sos.base.util.sosLogger.SOSLoggerSystem;
import sos.base.util.sosLogger.SOSLoggerSystem.OutputType;
import sos.police_v2.PoliceForceAgent;
import sos.tools.decisionMaker.definitions.SOSInformationModel;

public class PoliceInformationModel extends SOSInformationModel {

	public SOSLoggerSystem SS_Log;
	private int lastLock = -50;
	private int spentTime = 0;
	private  StandardEntity target;
 public PoliceInformationModel(SOSAgent<? extends Human> agent) {
		super(agent);
		SS_Log =  new SOSLoggerSystem(agent.me(), "Police/", true, OutputType.File, true);
		agent.sosLogger.addToAllLogType(SS_Log);
		
	}

	public PoliceForceAgent self() {
		return (PoliceForceAgent) getAgent();
	}

	public SOSLoggerSystem logReturn(){
		
		return SS_Log;
	}

	public PoliceForce getPolice() {
		return self().me();
	}

	public Area getAreaPosition() {
		return getPolice().getAreaPosition();
	}

	public void setLastTarget(Blockade bl) {
		self().lastTarget=bl;
	}
	
	public Blockade getLastTarget(){
		return self().lastTarget;
	}

	public int getLastLock() {
		return lastLock;
	}

	public void setLastLock(int lastLock) {
		this.lastLock = lastLock;
	}

	public int getSpentTime() {
		return spentTime;
	}

	public void setSpentTime(int spentTime) {
		this.spentTime = spentTime;
	}

	public StandardEntity getTarget() {
		return target;
	}

	public void setTarget(Human target) {
		this.target = target;
	}

}
