package sos.police_v2.interupts;

import rescuecore2.misc.Pair;
import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.Building;
import sos.base.entities.Civilian;
import sos.base.entities.Road;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class ReachableCivilianState extends PoliceAbstractIntruptState {
	Civilian civil = null;

	public ReachableCivilianState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);

	}

	@Override
	public void act() throws SOSActionException {
		log.info("acting as:" + this.getClass().getSimpleName());
		log.info("LOG IS NOT COMPLETED");
		makeReachableTo(civil);
	}

	@Override
	public boolean canMakeIntrupt() {
		if (agent.getNumberOfCiviliansOpening().first() > 10 && agent.getNumberOfCiviliansOpening().second() < agent.time() + 50)
		{
			agent.setNumberOfCiviliansOpening(new Pair<Integer, Integer>(0, agent.time()));
			return false;//TODO
		}

		if (civil != null && civilianReachableDone(civil)) {
			agent.log.info("setting reachablity true");
			civil.setIsReallyReachable(true);
		}

		if (civil != null && agent.getVisibleEntities(Civilian.class).contains(civil)) {
			if (!isReachableTo(civil)) {
				return true;
			}
			agent.setNumberOfCiviliansOpening(new Pair<Integer, Integer>(agent.getNumberOfCiviliansOpening().first() + 1, agent.time()));
			civil = null;
		}

		for (Civilian civilian : agent.getVisibleEntities(Civilian.class)) {
			if (civilian == null)
				continue;
			if (civilian.getHP() == 0)
				continue;
			if (isInFire(civilian) && civilian.getBuriedness() == 0)
				continue;
			if (!isReachableTo(civilian)) {
				if (thisCivilianIsUsefullToClear(civilian)) {
					civil = civilian;
					return true;
				}
			}
		}

		return false;
	}

	private boolean isInFire(Civilian civilian) {

		if (civilian.getAreaPosition() instanceof Road)
			return false;

		Building b = (Building) civilian.getAreaPosition();

		if (b.getFieryness() != 0 && b.getFieryness() < 4)
			return true;
		for (Building neighbour : b.realNeighbors_Building()) {
			if (neighbour.getFieryness() != 0 && neighbour.getFieryness() < 4)
				return true;
		}
		return false;
	}

	private boolean civilianReachableDone(Civilian assignCivil) {
		log.info("~~~~CIVILIANREACHABLEDONE!!!!!~~~");
		if (agent.location().equals(assignCivil.getPosition()))
			return true;
		if (assignCivil.isReallyReachable(true))
			return true;
		if (assignCivil.getPosition().isReallyReachable(true))
			return true;
		if (agent.location().getNeighbours().contains(assignCivil.getPosition()) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty()){
			log.info("3rd condish #rd condish heeeey THEREE!!!!!!");
			return true;
		}
		return false;

	}

	private boolean thisCivilianIsUsefullToClear(Civilian civilian) {
		if (agent.model().time() < 150) {
			if (SimpleDeathTime.getEasyLifeTime(civilian.getHP(), civilian.getDamage(), model().time()) < civilian.getBuriedness() / 3)
				return false;
			return true;
		}

		if (SimpleDeathTime.getEasyLifeTime(civilian.getHP(), civilian.getDamage(), model().time()) < 10)
			return false;

		return true;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub

	}

}
