package sos.police_v2.states;

import java.awt.Point;
import java.util.ArrayList;

import rescuecore2.misc.Pair;
import sos.base.entities.AmbulanceTeam;
import sos.base.entities.Building;
import sos.base.entities.GasStation;
import sos.base.entities.Refuge;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class AfterShockRefugeState extends PoliceAbstractState {
	Refuge ClosestRef = null;
	boolean aftershockHappened;
	GasStation ClosestGasStation = null;
	ArrayList<Refuge> myClusterRefuges = new ArrayList<Refuge>();
	ArrayList<GasStation> myClusterGasStationas = new ArrayList<GasStation>();
	ArrayList<Pair<AmbulanceTeam, Integer>> ambulanceScores;
	private boolean IsPrecomeDone = false;
	public AfterShockRefugeState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		if(!IsPrecomeDone){
			if(model().getLastAfterShockTime() > model().time() - 5)
				agent.setLastShockTime(model().getLastAfterShockTime());
			if(agent.getLastShockTime() != 0){
				aftershockHappened =true;
				myClusterRefuges = MyRefuges();
				myClusterGasStationas = MyGasStations();
			}
		}
	}

	@Override
	public void act() throws SOSActionException {
		if(aftershockHappened){
		
		
		
		if(myClusterRefuges.size() > 0){
			makeReachableTo(ChooseClosestRefuge());
			myClusterRefuges.remove(ChooseClosestRefuge());
		}

		if(myClusterGasStationas.size() > 0)
			makeReachableTo(ChooseClosestGasStation());
			myClusterGasStationas.remove(ChooseClosestGasStation());
	}}
	


	private ArrayList<Refuge> MyRefuges() {
		ArrayList<Refuge> refuges = new ArrayList<Refuge>();
		for (Building building : model().searchWorldModel.getClusterData().getBuildings())
			if (building instanceof Refuge && !building.isReallyReachable(true))
				refuges.add((Refuge) building);
		return refuges;
	}
	
	private ArrayList<GasStation> MyGasStations() {
		ArrayList<GasStation> gasStations = new ArrayList<GasStation>();
		for (Building building : model().searchWorldModel.getClusterData().getBuildings())
			if (building instanceof GasStation && !building.isReallyReachable(true))
				gasStations.add((GasStation) building);
		return gasStations;
	}
	
	private Refuge ChooseClosestRefuge(){
		int min = 19999999;
		for(Refuge clusRef: myClusterRefuges){
			if ( Point.distance(agent.me().getX(), agent.me().getY(), clusRef.getX(),clusRef.getY() )<min){
				min = (int) Point.distance(agent.me().getX(), agent.me().getY(), clusRef.getX(),clusRef.getY());
				ClosestRef = clusRef;
			}
		}
		return ClosestRef;
	}

	private GasStation ChooseClosestGasStation(){
		int min = 19999999;
		for(GasStation clusGS: myClusterGasStationas){
			if ( Point.distance(agent.me().getX(), agent.me().getY(), clusGS.getX(),clusGS.getY() )<min){
				min = (int) Point.distance(agent.me().getX(), agent.me().getY(), clusGS.getX(),clusGS.getY());
				ClosestGasStation = clusGS;
			}
		}
		return ClosestGasStation;
	}
	//TODO
	// inja copy paste shode ast!!!!!!!!!!!!!!!!!!!!!!!
	
//	private ArrayList<Pair<AmbulanceTeam, Integer>> chooseBestTarget() {
//		int max = 0;
//		ArrayList<Pair<AmbulanceTeam, Integer>> bestAmb = new ArrayList<Pair<AmbulanceTeam, Integer>>();
//		
//		for (Pair<AmbulanceTeam, Integer> amb : ambulanceScores) {
//			if (amb.second() > max) {
//				max = amb.second();
//				if (bestAmb.size() != 0)
//					bestAmb.clear();
//				bestAmb.add(new Pair<AmbulanceTeam, Integer>(amb.first(), max));
//			}
//		}
//		// TODO Auto-generated method stub
//		return bestAmb;
//		
//	}
//
//	private int numberOfAtInBuilding(Area areaPosition) {
//		int index = 0;
//		for (AmbulanceTeam at : model().ambulanceTeams()) {
//			if (at.isPositionDefined() && at.getPositionArea().equals(areaPosition))
//				index++;
//		}
//		return index;
//	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		if(model().getLastAfterShockTime() > model().time() - 5)
			agent.setLastShockTime(model().getLastAfterShockTime());
		if(agent.getLastShockTime() != 0){
			aftershockHappened =true;
			myClusterRefuges = MyRefuges();
			myClusterGasStationas = MyGasStations();
		}
		IsPrecomeDone = true;
	}
}
