package sos.police_v2.states;

import java.awt.Point;
import java.awt.Shape;
import java.util.Vector;

import sos.base.entities.Building;
import sos.base.entities.Civilian;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class CiriticalCivilianReachableity extends PoliceAbstractState {
	Shape dangerousArea;
	Vector<Civilian> ciriticalcivis;
	Civilian aim;

	public CiriticalCivilianReachableity(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		ciriticalcivis = new Vector<Civilian>();
	}
	@Override
	public void act() throws SOSActionException {
		int counter = 0;
		for (Building b : model().buildings()){
			if (b.updatedtime()>1)
				counter++;
			if(model().time()%10 == 0 ){
				log.warn("Counter= "+counter);
			}
		}
		dangerousArea = agent.getFireZoneManager().activeFirezoneShapeScale(1.5f);
		if (aim != null)
			if (civilianReachableDone(aim)) {
				aim.setIsReallyReachable(true);
				aim = null;
				log.debug(aim.getID()+"done in civilian reacablty");
			}
		if (aim == null)
			aim = FindCiriticalCivi();
		if (aim != null) {
			if (!isvalid(aim)) {
				aim = FindCiriticalCivi();
			}
			if (aim != null) {
				log.debug("have ciritical civilian to reachable :) <<<>>>"+aim.getID());
				makeReachableTo(aim);
				log.info("Ciritical civilian is reachable but still targeted");
			}
		}
	}

	private boolean isvalid(Civilian civi) {
		if(civi.getHP() == 0)
			return false;
		if (civi.getAreaPosition() instanceof Building) {
			if (civi.getBuriedness() == 0 && civi.getDamage() == 0)
				if (((Building) civi.getAreaPosition()).getFieryness() == 0)
					return true;
		}
		return false;
	}

	private boolean civilianReachableDone(Civilian assignCivil) {
		if (agent.location().equals(assignCivil.getPosition()))
			return true;
		if (assignCivil.isReallyReachable(true))
			return true;
		if (assignCivil.getPosition().isReallyReachable(true))
			return true;
		if (agent.location().getNeighbours().contains(assignCivil.getPosition()) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty())
			return true;
		return false;

	}

	private Civilian FindCiriticalCivi() {
		ciriticalcivis.clear();
		for (Civilian civi : agent.model().civilians()) {
			if (civi.getAreaPosition() instanceof Building) {
				if (civi.getBuriedness() == 0 && civi.getDamage() == 0)
					if (((Building) civi.getAreaPosition()).getFieryness() == 0)
						if (agent.buildzone.contains(civi.getAreaPosition())) {
							if (dangerousArea.contains(civi.getX(), civi.getY()))
								ciriticalcivis.add(civi);
						}
			}
		}
		Civilian target = null;
		if (ciriticalcivis.size() > 0) {
			target = ciriticalcivis.firstElement();
			for (Civilian temp : ciriticalcivis) {
				if (Point.distance(agent.me().getX(), agent.me().getY(), temp.getX(), temp.getY()) < Point.distance(agent.me().getX(), agent.me().getY(), target.getX(), target.getY()))
					target = temp;
			}
		}

		return target;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		
	}

}
