package sos.police_v2.states;

import java.awt.Shape;
import java.util.ArrayList;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.ambulance_v2.decision.AmbUtile;
import sos.ambulance_v2.tools.GraphUsage;
import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.Civilian;
import sos.base.entities.Refuge;
import sos.base.message.structure.MessageConstants.Type;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.decision.SSUtils;
import sos.police_v2.interupts.PoliceAbstractIntruptState;

public class CivilReachable extends PoliceAbstractIntruptState {
	private GraphUsage gu;
	int PrimaryOpening = 0;
	boolean IsPrecDne = false;
	ArrayList<Civilian> civis = new ArrayList<Civilian>();
	ArrayList<Civilian> unreachcivs = new ArrayList<Civilian>();
	private Civilian targetcivilian = null;
	Pair<Civilian, Integer> bestCiv = null;
	Shape dangerousArea;
	public Shape myCluster = model().searchWorldModel.getClusterData().getConvexShape();
	//cheghad bashe in int e? (gozashtam 5 ta baz kone avale kR vaL nMidoonam cheghad bashe khoobe)

	public CivilReachable(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		// TODO Auto-generated constructor stub
		if(!IsPrecDne)
			VisibleCivs();
	}

	@Override
	public boolean canMakeIntrupt() {
		// TODO Auto-generated method stub
		if(PrimaryOpening >10 && !(agent.BeginCivReach))
			return true;
		
		
		return false;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		VisibleCivs();
		IsPrecDne = true;

	}

	@Override
	public void act() throws SOSActionException {
		// TODO Auto-generated method stub
		if (targetcivilian != null && civilianReachableDone(targetcivilian)) {
			targetcivilian.setIsReallyReachable(true);
			civis.remove(targetcivilian);
			PrimaryOpening ++;
			
			targetcivilian = null;
		}

		if (!isValidCivilian(targetcivilian)) {
			targetcivilian = chooseBestCivilian();
		}

		if (targetcivilian != null) {
			Pair<Area, Point2D> ep = getEntrancePoint(targetcivilian
					.getAreaPosition());
			if (ep == null) {
				targetcivilian = null;
				return;
			}
			moveToPoint(ep);
		}
	}
	private void VisibleCivs() {

		//		ClusterData myclusterData = agent.newSearch.getSearchWorld()
		//				.getClusterData();
		for (Civilian civ : agent.getVisibleEntities(Civilian.class)) {
			if (!SSUtils.isValidCivilian(civ, agent, true))
				continue;
			if(!isReachableTo(civ))
				unreachcivs.add(civ);
			}
	}
	private Civilian chooseBestCivilian() {
		double minCost = 199999999;
		Civilian targetCiv = null;
		if (PrimaryOpening < 10 || agent.BeginCivReach ) {
			for (Civilian civil : unreachcivs) {
				int timeToRefuge=0;
					if (agent.model().refuges().size() == 0) {
						timeToRefuge = 0;
					}
					else
						timeToRefuge = civil.getRescueInfo().getTimeToRefuge();
					int cost = 0;
					int minxccc = 199999;
					int moveDistance = agent.model().getDistance(agent.me().getPositionArea(), civil.getAreaPosition());
					int numberOfAmb = AmbUtile.numberOfAmbNeeded(timeToRefuge, civil, civil.getRescueInfo().getDeathTime());
//					int cost = civil.getBuriedness() + (civil.getHP() * civil.getRescueInfo().getDeathTime()) + moveDistance;
//					int cost = numberOfAmb / (AmbUtile.numberOfFreeAmbs(model().ambulanceTeams().get(0)) + 1) + civil.getBuriedness() + (civil.getHP() * civil.getRescueInfo().getDeathTime()) + moveDistance;
					if (agent.messageSystem.type == Type.LowComunication && agent.messageSystem.type == Type.NoComunication) {
						int moveTime = gu.getFoolMoveTimeFromTo(agent.me().getAreaPosition(), civil.getAreaPosition());
						cost = ((20 + (moveTime)) * civil.getRescueInfo().getDeathTime()) + 1 / ((civil.getBuriedness() * (civil.getHP() * 15)) + 1);

					}
					else
						cost = civil.getBuriedness() + (civil.getHP() * civil.getRescueInfo().getDeathTime()) + moveDistance;

					if (cost < minxccc){
						minxccc = cost;
						targetCiv = civil;
					}
					
				}
			}
			log.info("interrupt^^^^^^in CivilReach~ChoOsInG TarGet");
			return targetCiv;
		}
	
private boolean civilianReachableDone(Civilian assignCivil) {
	if (agent.location().equals(assignCivil.getPosition()))
		return true;
	if (assignCivil.isReallyReachable(true))
		return true;
	if (assignCivil.getPosition().isReallyReachable(true))
		return true;
	if (agent.location().getNeighbours()
			.contains(assignCivil.getPosition())
			&& agent.location().isBlockadesDefined()
			&& agent.location().getBlockades().isEmpty())
		return true;
	return false;

}
private boolean isValidCivilian(Civilian target) {
	if (target == null || target.isUnkonwnCivilian())
		return false;
	if (!(target.getAreaPosition() instanceof Building)
			|| (isInFire(target)))
		return false;
	if (target.getAreaPosition() instanceof Refuge)
		return false;

	if (!target.isPositionDefined())
		return false;
	if (target.isReallyReachable(true)
			|| (agent.isReachableTo(target.getPositionPair()))) {
		agent.log.info("in is valid civilian and the civ is not valid");
		return false;

	} else {
		agent.log.info("Saina . Civ is not reachable");
	}
	// TODO
	if (target.getHP() == 0)
		return false;
	if (target.getBuriedness() == 0)
		return false;
	//		if (agent.model().time() > 160)
	//			return true;
	if (isNearFire(target) && target.getBuriedness() > 30)
		return false;
	if (SimpleDeathTime.getEasyLifeTime(target.getHP(), target.getDamage(),
			target.updatedtime()) - agent.model().time() < target
			.getBuriedness() / 3 + 5) {
		return false;
	}

	return true;
}
private boolean isNearFire(Civilian civilian) {

	Building b = (Building) civilian.getAreaPosition();
	for (Building neighbour : b.realNeighbors_Building()) {
		if (neighbour.getFieryness() != 0 && neighbour.getFieryness() < 4)
			return true;
	}
	return false;
}

private boolean isInFire(Civilian civil) {

	Building bui = (Building) civil.getAreaPosition();

	if (bui.getFieryness() != 0 && bui.getFieryness() < 4)
		return true;
	return false;
}


}