package sos.police_v2.states;

import java.util.HashSet;
import java.util.Vector;

import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.Road;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class ClearHighwayState extends PoliceAbstractState {
		Vector<Road> highwayzone;

	public ClearHighwayState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		highwayzone= makeHighWaysZone(agent.newSearch.getSearchWorld().getMapClusterType().getMyClusterBuildings());
	}

	@Override
	public void act() throws SOSActionException {
		if(highwayzone!=null && highwayzone.size()>0){
			checkaim();
			makeReachableTo(highwayzone);
		}

	}
	private boolean aimElementDone(Road  area) {
		if (agent.location().equals(area))
			return true;
		if (area.isReallyReachable(true))
			return true;
		if (agent.location().getNeighbours().contains(area) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty())
			return true;
		if(isReachableTo(area))
			return true;
		return false;
	}
	
	private void checkaim() {
		for(int i=highwayzone.size()-1;i>-1;i--){
			if(aimElementDone(highwayzone.elementAt(i))){
				highwayzone.remove(i);
			}
		}
		
	}
	
	
	private Vector<Road> makeHighWaysZone(HashSet<Building> myClusterBuildings) {
		Vector<Road> temp = new Vector<Road>();
		Road road = null;
		Vector<Road> highways=new Vector<Road>();
		for (Building building : myClusterBuildings) {
			for (sos.base.entities.Area area : building.getRoadsInSight()) {
				if (area != null)
					if (area instanceof Road) {
						road = (Road) area;
						if (!temp.contains(road))
							temp.add(road);
					}
			}
		}
		for(Area highway:agent.model().getHighways()){
			if(highway instanceof Road){
				if(temp.contains(highway))
					highways.add((Road) highway);
			}
		}
		System.err.println("PoliceForce["+agent.getID()+"] : got Highway in zone with "+highways.size()+" highway");
		return highways;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		
	}
}