package sos.police_v2.states;

import java.awt.Point;
import java.util.Vector;

import rescuecore2.worldmodel.EntityID;
import sos.base.entities.AmbulanceTeam;
import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.FireBrigade;
import sos.base.entities.Human;
import sos.base.entities.PoliceForce;
import sos.base.entities.Refuge;
import sos.base.move.types.PoliceMove;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class ConnectAgentState extends PoliceAbstractState {
	private Vector<Node> agents;
	private Vector<RefugeNode> refuges;
	private Vector<tasknumpolice> Tasknumpolices;
	private boolean thinkagain = false;
	private Vector<Area> aim = null;
	private Vector<Area> aim2 = null;
	private Vector<Human> aimagent = null;
	
	
	public ConnectAgentState(PoliceForceAgent policeForceAgent) {

		super(policeForceAgent);
		agents = new Vector<Node>();
		refuges = new Vector<ConnectAgentState.RefugeNode>();
		Tasknumpolices = new Vector<ConnectAgentState.tasknumpolice>();
		firstThink();
		System.err.println(agent.me().getID() + "i got " + aim.size() + " agent to reachable");
	}

	@Override
	public void act() throws SOSActionException {

		if (getAim() != null && getAim().size() > 0) {
			checkaim(getAim());
			log.info("^^ Acting as getAim");
			makeReachableTo(getAim());
		}
		if (model().time() >= 6 && !thinkagain) {
			thinkAgain();
			log.info("^^ Making thinkagain true");
			thinkagain = true;
		}
		
		if (aim2 != null && aim2.size() > 0) {
			checkaim(aim2);
			log.info("^^ Making reachable to aim2: " + aim2.size());
			makeReachableTo(aim2);
		}

	}

	private boolean aimElementDone(Area area) {
		if (agent.location().equals(area))
			return true;
		if (area.isReallyReachable(true))
			return true;
		//				if (agent.location().getNeighbours().contains(area) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty())
		//					return true;
		return false;
	}

	private void checkaim(Vector<Area> targets) {
		boolean done = false;
		
		
		for (int i = targets.size() - 1; i > -1; i--) {
			done = false;
			if (aimElementDone(targets.elementAt(i))) {
				targets.remove(i);
				done = true;
			}
			if (!done){
				if (targets.elementAt(i) instanceof Building)
					if (((Building) targets.elementAt(i)).getFieryness() != 0 && ((Building) targets.elementAt(i)).getFieryness() < 4){
						targets.remove(i);
						done=true;
					}
			}
		}

	}

	public void firstThink() {
		Node nodetemp;
		for (FireBrigade fb : model().fireBrigades()) {
			nodetemp = new Node();
			nodetemp.human = fb;
			nodetemp.firstarea = fb.getAreaPosition();
			nodetemp.police = null;
			agents.add(nodetemp);
		}
		for (AmbulanceTeam ab : model().ambulanceTeams()) {
			nodetemp = new Node();
			nodetemp.human = ab;
			nodetemp.firstarea = ab.getAreaPosition();
			nodetemp.police = null;
			agents.add(nodetemp);
		}
		for (PoliceForce po : model().policeForces()) {
			nodetemp = new Node();
			nodetemp.human = po;
			nodetemp.firstarea = po.getAreaPosition();
			nodetemp.police = null;
			agents.add(nodetemp);
		}

		tasknumpolice policetemp;
		for (PoliceForce po : model().policeForces()) {
			policetemp = new tasknumpolice();
			policetemp.police = po;
			po.lastaim = po.getAreaPosition();
			policetemp.tasknum = 0;
			Tasknumpolices.add(policetemp);
		}

		RefugeNode refugeNode;
		for (Refuge refuge : model().refuges()) {
			refugeNode = new RefugeNode();
			refugeNode.refuge = refuge;
			refuges.add(refugeNode);
		}

		for (Node node : agents) {
			policesort();
			tasknumpolice bestpolice = Tasknumpolices.elementAt(0);
			for (tasknumpolice police : Tasknumpolices) {
				if (!police.police.equals(node.human))
					if (findNode(police.police.getID()).police == null || !(findNode(police.police.getID()).police.equals(node.human)))
						//						if ((police.police.distance(node.human.getAreaPosition()) / 1000) < (bestpolice.police.distance(node.human.getAreaPosition()) / 1000)) {
						//						if (agent.move.getPathFromTo(police.police.lastaim, node.human.getAreaPosition(), PoliceMove.class).getLenght() / 1000 < agent.move.getPathFromTo(bestpolice.police.lastaim, node.human.getAreaPosition(), PoliceMove.class).getLenght() / 1000) {
						if (Point.distance(police.police.lastaim.getX(), police.police.lastaim.getY(), node.human.getX(), node.human.getY()) / 5000 < Point.distance(bestpolice.police.lastaim.getX(), bestpolice.police.lastaim.getY(), node.human.getX(), node.human.getY()) / 5000) {
							bestpolice = police;
						}
			}
			node.police = bestpolice.police;
			bestpolice.police.lastaim = node.human.getAreaPosition();
			bestpolice.tasknum++;
		}
		aim = (bestAimSort(agent.me()));

		for (RefugeNode node : refuges) {
			policesort();
			tasknumpolice bestLeftpolice = null;
			tasknumpolice bestRightpolice = null;

			for (tasknumpolice police : Tasknumpolices) {
				if (police.police.getX() > node.refuge.getX()) {
					//right police

					if (bestRightpolice != null) {
						if (Point.distance(police.police.lastaim.getX(), police.police.lastaim.getY(), node.refuge.getX(), node.refuge.getY()) / 5000 < Point.distance(bestRightpolice.police.lastaim.getX(), bestRightpolice.police.lastaim.getY(), node.refuge.getX(), node.refuge.getY()) / 5000)
							bestRightpolice = police;
					} else {
						bestRightpolice = police;
					}
				} else {
					//Left police
					if (bestLeftpolice != null) {
						if (Point.distance(police.police.lastaim.getX(), police.police.lastaim.getY(), node.refuge.getX(), node.refuge.getY()) / 5000 < Point.distance(bestLeftpolice.police.lastaim.getX(), bestLeftpolice.police.lastaim.getY(), node.refuge.getX(), node.refuge.getY()) / 5000)
							bestLeftpolice = police;
					} else {
						bestLeftpolice = police;
					}
				}
			}

			if (bestRightpolice != null) {
				if (bestRightpolice.police.equals(agent.me())) {
					getAim().add(node.refuge.getAreaPosition());
				}
				node.rightpolice = bestRightpolice.police;
				bestRightpolice.tasknum++;
			}
			if (bestLeftpolice != null) {
				if (bestLeftpolice.police.equals(agent.me())) {
					getAim().add(node.refuge.getAreaPosition());
				}
				bestLeftpolice.tasknum++;
				node.leftpolice = bestLeftpolice.police;
			}

			//			if (bestLeftpolice.police.equals(agent.me()) || bestRightpolice.police.equals(agent.me())) {
			////				aim.add(node.refuge.getAreaPosition());
			//			}

		}

	}

	private Vector<Area> thinkAgain() {
		Vector<PoliceForce> trapedPolice = new Vector<PoliceForce>();
		Vector<Node> nonepoliceagent = new Vector<ConnectAgentState.Node>();
		aim2 = new Vector<Area>();
		for (PoliceForce policeForce : model().policeForces()) {
			if (policeForce.getBuriedness() > 0)
				trapedPolice.add(policeForce);
		}
		//		System.err.println("found police in trape"+trapedPolice.size());
		for (Node node : agents)
			if (trapedPolice.contains(node.police))
				nonepoliceagent.add(node);
		//		System.err.println("found ppl must be reachable"+nonepoliceagent.size());
		for (Node node : nonepoliceagent) {
			policesort();
			tasknumpolice bestpolice = nonetrapedpolice();
			if (bestpolice != null) {
				for (tasknumpolice police : Tasknumpolices) {
					//					if (!police.police.equals(node.human))
					if (!trapedPolice.contains(police.police))
						//							if (findNode(police.police.getID()).police == null || !(findNode(police.police.getID()).police.equals(node.human)))
						//						if ((police.police.distance(node.human.getAreaPosition()) / 1000) < (bestpolice.police.distance(node.human.getAreaPosition()) / 1000)) {
						//						if (agent.move.getPathFromTo(police.police.lastaim, node.human.getAreaPosition(), PoliceMove.class).getLenght() / 1000 < agent.move.getPathFromTo(bestpolice.police.lastaim, node.human.getAreaPosition(), PoliceMove.class).getLenght() / 1000) {
						if (Point.distance(police.police.lastaim.getX(), police.police.lastaim.getY(), node.firstarea.getX(), node.firstarea.getY()) / 5000 < Point.distance(bestpolice.police.lastaim.getX(), bestpolice.police.lastaim.getY(), node.firstarea.getX(), node.firstarea.getY()) / 5000) {
							bestpolice = police;
						}
				}
				node.police = bestpolice.police;
				bestpolice.police.lastaim = node.human.getAreaPosition();
				bestpolice.tasknum++;
				//System.out.println("best police for "+node.human.getID()+" is "+bestpolice.police.getID());
				if (bestpolice.police.equals(model().me()))
					aim2.add(node.human.getAreaPosition());
			}
		}

		return null;

	}

	private tasknumpolice nonetrapedpolice() {
		int i = 0;
		while (i < Tasknumpolices.size()) {
			if (Tasknumpolices.elementAt(i).police.getBuriedness() == 0)
				return Tasknumpolices.elementAt(i);
		}
		return null;
	}

	private Node findNode(EntityID ID) {
		for (Node temp : agents) {
			if (temp.human.getID() == ID) {
				return temp;
			}
		}
		return null;
	}

	private Vector<Area> bestAimSort(PoliceForce police) {
		int nodenum = 0;
		for (Node node : agents) {
			if (node.police.equals(agent.me()))
				nodenum++;
		}
		Vector<Area> temp = new Vector<Area>();
		aimagent = new Vector<Human>();
		temp.add(police.getAreaPosition());
		for (int i = 0; i < nodenum; i++) {
			Node nearnode = null;
			for (Node node : agents) {
				if (node.police.equals(agent.me())) {
					if (nearnode != null && (agent.move.getPathFromTo(temp.lastElement().getAreaPosition(), node.human.getAreaPosition(), PoliceMove.class).getLenght() < agent.move.getPathFromTo(temp.lastElement().getAreaPosition(), nearnode.human.getAreaPosition(), PoliceMove.class).getLenght())) {
						nearnode = node;
					} else {
						nearnode = node;
					}
				}

			}
			aimagent.add(nearnode.human);
			temp.add(nearnode.human.getAreaPosition());
			agents.remove(nearnode);
			nearnode = null;
		}
		temp.remove(0);
		return temp;

	}

	/*
	 * Sort Police By Task Numbers
	 */

	private void policesort() {
		boolean rightplace;
		int j = 0;
		for (int i = 1; i < Tasknumpolices.size(); i++) {
			tasknumpolice temp;
			rightplace = false;
			j = i - 1;
			while (!rightplace && j > -1) {
				if (Tasknumpolices.elementAt(j + 1).tasknum < Tasknumpolices.elementAt(j).tasknum) {
					temp = Tasknumpolices.elementAt(j);
					Tasknumpolices.setElementAt(Tasknumpolices.elementAt(j + 1), j);
					Tasknumpolices.setElementAt(temp, j + 1);
					j--;
				} else {
					rightplace = true;
				}
			}
		}
	}

	public Vector<Area> getAim() {
		return aim;
	}

	private class Node {
		Human human;
		PoliceForce police;
		Area firstarea;
	}

	private class tasknumpolice {
		PoliceForce police;
		int tasknum;
	}

	private class RefugeNode {
		Refuge refuge;
		PoliceForce leftpolice = null;
		PoliceForce rightpolice = null;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		
	}
}
