package sos.police_v2.states;

import java.util.ArrayList;
import java.util.Vector;

import rescuecore2.geometry.Point2D;
import sos.base.entities.PoliceForce;
import sos.base.entities.Road;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.tool.FireZone;
import sos.police_v2.tool.FireZoneManager;
import sos.tools.geometry.SOSGeometryTools;
import be.abeel.util.Pair;

public class FireReachableState extends PoliceAbstractState {
	Vector<Road> aim = new Vector<Road>();
	Vector<Road> LogClearedBuildings = new Vector<Road>();//vas log
	private FireZoneManager fireZoneManager;
	private int clearedRoads = 0;
	private Road oldtarget = null;
	private FireZone oldfz = null;

	ArrayList<Pair<Integer, PoliceForce>> polices = new ArrayList<Pair<Integer, PoliceForce>>();

	public FireReachableState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		fireZoneManager = agent.getFireZoneManager();
	}

	@Override
	public void act() throws SOSActionException {

		if (fireZoneManager == null)
			log.info("fire zone null");
		fireZoneManager.updateFireZone();
		fireZoneManager.fireZoneLog(model().log());
		if (fireZoneManager.getFireZones().isEmpty()){
			log.info("** fire zones are null *");
			return;
		}
		if(OpenOnceLog())
			log.info("!!!!!!!!CHECKING A ROAD MORE THAN ONE TIME, roadID="+aim.elementAt(aim.size()-1).getID());
		FireZone bestFireZone = fireZoneManager.getBestForMe(agent);
		if (bestFireZone == null) {
			log.info("** Best Fire Zone null**");
			return;
		}

		log.info("need0 " + fireZoneManager.need0 + "  need1 " + fireZoneManager.need1 +
				" need2 " + fireZoneManager.need2 );
		if (oldfz == null)
			oldfz = bestFireZone;
		if (bestFireZone != oldfz)
		{
			clearedRoads = 0;
			bestFireZone = oldfz;
		}

		float factor = 0;
		if (bestFireZone.pfWorkingNum == 1) {
			factor = bestFireZone.firstTaskSize;
		}
		else {
			factor = (2 / ((float) bestFireZone.pfWorkingNum)) * bestFireZone.firstTaskSize;
		}
		
		log.info("factor is : "+ factor+ "pf working "+bestFireZone.pfWorkingNum + " task size :" + bestFireZone.firstTaskSize );
		if (clearedRoads > factor) {
			log.info("don't have to work");
			return;
		}

		if (model().fieryBuildings().size() > 0) {
			log.info("** FieryBuilding size:" + model().fieryBuildings().size());

			if (aim != null && aim.size() > 0) {
				log.info("** aim size" + aim.size());
				checkaim();
				float min = 199999;
				Road best = null;
				for (Road a : aim) {
					float dis = (float) SOSGeometryTools.distance(a.getAreaPosition(), new Point2D(agent.model().searchWorldModel.getClusterData().getX(), agent.model().searchWorldModel.getClusterData().getY()));
					if (dis < min) {
						min = dis;
						best = a;
					}

				}

				if (oldtarget == null)
					oldtarget = best;

				if (best != oldtarget)
					clearedRoads++;

				best = oldtarget;
				makeReachableTo(best);
			}

			else {
				log.info("aim was null");
				aim = fireZoneManager.makePoliceTaskZone(bestFireZone);
			}

			aim = fireZoneManager.makePoliceTaskZone(bestFireZone);

		}
	}

	private boolean aimElementDone(Road area) {
		if (agent.location().equals(area))
			return true;
		if (area.isReallyReachable(true))
			return true;
		if (agent.location().getNeighbours().contains(area) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty())
			return true;
		if (isReachableTo(area))
			return true;
		return false;
	}
	private boolean OpenOnceLog(){
		checkaim();
		for(Road road : LogClearedBuildings)
			if (aim.elementAt(aim.size()-1) == road)
				return true;
		
		return false;
	}
	private void checkaim() {
		for (int i = aim.size() - 1; i > -1; i--) {
			if (aimElementDone(aim.elementAt(i))) {
				log.info("aim is done." + aim.elementAt(i).getID());
				aim.remove(i);
			}
		}

	}

	public FireZoneManager getFireZoneManager() {
		return fireZoneManager;
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub

	}
}
