package sos.police_v2.states;

import java.awt.Shape;

import sos.ambulance_v2.tools.SimpleDeathTime;
import sos.base.entities.Refuge;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.interupts.PoliceAbstractIntruptState;

public class FirstCheckState extends PoliceAbstractIntruptState {
	Refuge refuge = null;
	public Shape firezone;
	int DeathTime = SimpleDeathTime.getEasyLifeTime(agent.me().getHP(), agent.me().getDamage(), model().time());
	int TimeToRefuge = agent.me().getRescueInfo().getTimeToRefuge();
	
	public FirstCheckState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
	}

	

	@Override
	public void act() throws SOSActionException {
		firezone=agent.getFireZoneManager().firezoneShapeScale(0.8f);
		if( DeathTime > TimeToRefuge + 2 && DeathTime < TimeToRefuge + 6){
			if (refuge == null)
				refuge = nearRefuge();
			if (refuge != null) {
				move(refuge);
			}
		}

	}

	private Refuge nearRefuge() {
		Refuge bestrefuge = null;
		if (model().refuges().size() > 0) {
			bestrefuge = model().refuges().get(0);
			for (Refuge refuge : model().refuges()) {
				if (agent.me().distance(bestrefuge) < agent.me().distance(refuge)) {
					bestrefuge = refuge;
				}

			}
		}
		return bestrefuge;
	}

	@Override
	public boolean canMakeIntrupt() {
		if(agent.me().getDamage() >= 50)
			return true;
		return false;
	}



	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		
	}
}
