package sos.police_v2.states;

import java.awt.Point;
import java.awt.Shape;
import java.awt.geom.Point2D;
import java.util.ArrayList;

import rescuecore2.misc.Pair;
import sos.base.entities.Hydrant;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.tool.FireZone;
import sos.police_v2.tool.FireZoneManager;

public class HydrantState extends PoliceAbstractState {
	ArrayList<Hydrant> hydrnts= new ArrayList<Hydrant>();
	ArrayList<Hydrant> removed= new ArrayList<Hydrant>();
	ArrayList<Pair<Hydrant, Float>> sortList;
	ArrayList<Hydrant> willReachable= new ArrayList<Hydrant>();
	float firezoneDis;
	float min;
	int counter;
	Hydrant ClosestHyd;
	Pair<Hydrant, Float> pairWillReachable;
	Hydrant hydWillReachable;
	FireZone bestFirezone;
	private FireZoneManager fireZoneManager;
	private boolean IsPrecomDone = false;
	public HydrantState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		fireZoneManager = agent.getFireZoneManager();
		if(!IsPrecomDone){
			if (!model().refuges().isEmpty())
				return;
			Shape myCluster = model().searchWorldModel.getClusterData()
					.getConvexShape();
			//sortList = new ArrayList<Pair<Hydrant, Float>>();

			for (Hydrant hydrant : model().Hydrants()) {

				if (myCluster.contains(new Point2D.Double(hydrant.getX(), hydrant
						.getY())))

					hydrnts.add(hydrant);
			}

			hydrantSort();
		}
	}

	@Override
	public void precompute() {
		if (!model().refuges().isEmpty())
			return;
		Shape myCluster = model().searchWorldModel.getClusterData()
				.getConvexShape();
		//sortList = new ArrayList<Pair<Hydrant, Float>>();

		for (Hydrant hydrant : model().Hydrants()) {

			if (myCluster.contains(new Point2D.Double(hydrant.getX(), hydrant
					.getY())))

				hydrnts.add(hydrant);
		}

		hydrantSort();
		IsPrecomDone = true;
	}

	@Override
	public void act() throws SOSActionException {
		ClosestHyd = ChooseClosestHydrant();
		if (hydrnts.isEmpty())
			return;

		if (willReachable.isEmpty())
			return;
		if (!isReachableTo(ClosestHyd)) {
			makeReachableTo(ClosestHyd);
		}
		willReachable.remove(ClosestHyd);

	}

	private ArrayList<Hydrant> hydrantSort() {
		bestFirezone = fireZoneManager.getBestForMe(agent);
		for (Hydrant hyd : hydrnts) {
			firezoneDis = (float) Point.distance(hyd.getX(), hyd.getY(), bestFirezone.getCenterOfZone().getX(), bestFirezone.getCenterOfZone().getY());
			sortList.add(new Pair<Hydrant, Float>(hyd, firezoneDis));

		}
		for (counter = 0; counter < 5; counter++) {
			min = 1999999;
			for (Pair<Hydrant, Float> sl : sortList) {
				if (sl.second() < min) {
					min = sl.second();
					pairWillReachable = sl;
				}

			}
			willReachable.add(pairWillReachable.first());
			sortList.remove(pairWillReachable);
			if (sortList.isEmpty())
				break;

		}
		return willReachable;
	}

	private Hydrant ChooseClosestHydrant() {
		int min = 1999999;
		for (Hydrant hydr : willReachable) {
			if ((int) Point.distance(hydr.getX(), hydr.getY(), agent.me().getX(), agent.me().getY()) < min) {
				min = (int) Point.distance(hydr.getX(), hydr.getY(), agent.me().getX(), agent.me().getY());
				hydWillReachable = hydr;
			}
		}
		return hydWillReachable;
	}

}
