package sos.police_v2.states;


import java.awt.geom.Point2D;

import sos.base.entities.Blockade;
import sos.base.entities.Road;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.decision.SSUtils;
import sos.police_v2.interupts.PoliceAbstractIntruptState;

public class MeStuck extends PoliceAbstractIntruptState {
	private Blockade target;

	public MeStuck(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
	}

	@Override
	public boolean canMakeIntrupt() {
		if(agent.time()<4)
			return false;
		if (!(agent.me().getAreaPosition() instanceof Road))
			return false;
		target = null;
		for (Blockade blockade : agent.me().getAreaPosition().getBlockades()) {
			if (!SSUtils.isValid(blockade))
				continue;
			if (blockade.getShape().contains(new Point2D.Double(agent.me().getX(), agent.me().getY()))) {
				target = blockade;
				return true;
			}
		}
		return false;
	}

	@Override
	public void precompute() {

	}

	@Override
	public void act() throws SOSActionException {
		if (target != null){
			log.info("^^ target is: " + target.getID());
			clear(target);
		}
	}

}
