package sos.police_v2.states;

import java.awt.Point;
import java.util.ArrayList;
import java.util.HashSet;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.Civilian;
import sos.base.message.structure.MessageConstants.Type;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.decision.SSUtils;

public class OpenCIviliansWIthoutBurridness extends PoliceAbstractState {
	private boolean IsPrecomDone = false;
	public OpenCIviliansWIthoutBurridness(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		// TODO Auto-generated constructor stub
		if(!IsPrecomDone){
			myClusterBuilding = model().searchWorldModel.getClusterData().getBuildings();

		}
	}

	//change think for map rule
	boolean haveAfterShock = false;
	private HashSet<Building> myClusterBuilding;

	@Override
	public void precompute() {
		myClusterBuilding = model().searchWorldModel.getClusterData().getBuildings();
		IsPrecomDone = true;
	}

	Civilian assignCivil = null;

	@Override
	public void act() throws SOSActionException {
		log.info("acting as:" + this);
		log.debug("assigned cilvilian=" + assignCivil);
		if (assignCivil != null && missionComplete(assignCivil)) {
			log.info("missoin complete!!" + assignCivil + " opened!(Healty)");
			assignCivil.setIsReallyReachable(true);
			log.info("civilian maked reachable " + assignCivil.getID());
			assignCivil = null;
		}

		if (!SSUtils.isValidHealtyCivilian(assignCivil, agent)) {
			if (assignCivil != null)
				log.info("civilian is not valid more" + assignCivil.getID());
			assignCivil = assignNewCivilian();
		}

		log.debug("current assigned civilian is:" + assignCivil);
		if (assignCivil != null) {
			Pair<Area, Point2D> ep = getEntrancePoint(assignCivil.getAreaPosition());
			if (ep == null) {
				log.info("how?????");
				assignCivil = null;
				return;
			}
			moveToPoint(ep);

		}

	}

	private Civilian assignNewCivilian() {
		myClusterBuilding = model().searchWorldModel.getClusterData().getBuildings();
		ArrayList<Civilian> civis = new ArrayList<Civilian>();

		if (agent.messageSystem.type == Type.NoComunication) {
			for (Civilian civilian : model().civilians()) {
				if (SSUtils.isValidHealtyCivilian(civilian, agent))
					if (myClusterBuilding.contains(civilian.getAreaPosition())) {
						if (!civis.contains(civilian))
							civis.add(civilian);
					}
			}

			if (civis.size() > 0) {
				Civilian target = civis.get(0);
				for (Civilian civilian : civis) {
					if (target == civilian)
						continue;
					if (Point.distance(agent.me().getX(), agent.me().getY(), civilian.getX(), civilian.getY())
					< Point.distance(agent.me().getX(), agent.me().getY(), target.getX(), target.getY())) {
						target = civilian;
					}
				}

				log.info("found ciritical civilian =" + target.getID());
				return target;
			}
		}
		else {
			for (Civilian civilian : model().civilians()) {
				if (SSUtils.isValidHealtyCivilian(civilian, agent) && myClusterBuilding.contains(civilian.getAreaPosition()))
					if (model().time() - civilian.updatedtime() < 10)
						if (!civis.contains(civilian))
							civis.add(civilian);
			}
			if (civis.size() > 0) {
				Civilian target = civis.get(0);
				for (Civilian civilian : civis) {
					if (target == civilian)
						continue;
					if (Point.distance(agent.me().getX(), agent.me().getY(), civilian.getX(), civilian.getY())
					< Point.distance(agent.me().getX(), agent.me().getY(), target.getX(), target.getY())) {
						target = civilian;
					}
				}
				log.info("found ciritical civilian =" + target.getID());
				return target;
			}
		}
		return null;
	}

	private boolean missionComplete(Civilian assignCivil) {
		if (agent.location().equals(assignCivil.getPosition()))
			return true;
		if (assignCivil.isReallyReachable(true))
			return true;
		if (assignCivil.getPosition().isReallyReachable(true))
			return true;
		if (agent.location().getNeighbours().contains(assignCivil.getPosition()) && agent.location().isBlockadesDefined() && agent.location().getBlockades().isEmpty())
			return true;
		return false;
	}

}
