package sos.police_v2.states;


import java.util.ArrayList;

import rescuecore2.geometry.Point2D;
import rescuecore2.misc.Pair;
import sos.base.entities.Area;
import sos.base.entities.Building;
import sos.base.entities.StandardEntity;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.police_v2.preCompute.Task;
import sos.search_v2.tools.SearchTask;
public class OpenClusterFire extends PoliceAbstractState {
	
//Entrance
	ArrayList<Building> FiryBuildings = new ArrayList<Building>();
	public OpenClusterFire(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
	}

	@Override
	public void act() throws SOSActionException {
		
		FiryBuildings.clear();
		
		for ( Building b : agent.model().searchWorldModel.getClusterData().getBuildings()){
			if(b.isBurning() && agent.time() - b.updatedtime() > 3 && !b.isReallyReachable(true))
				FiryBuildings.add(b);
		}
		SortFiryBuilding();
		for (Building fb: FiryBuildings){
		Pair<Area, Point2D> ep = getEntrancePoint(fb.getAreaPosition());
		if (ep == null) 
			continue;
		
		moveToPoint(ep);
			
		}
	}

	private void SortFiryBuilding(){
	//	new Weight(null).setWeights(FiryBuildings);
	}
	public void handleTask(Task<? extends StandardEntity> task) throws SOSActionException {
		log.debug("Handeling task " + task);
		if (task == null) {
			log.info("Noting to do in Search???");
			return;
		} else {
			log.info("!!!!!!!!!!!!!KHODSUZI?!!!task ine="+task.getRealEntity()+"    "+task);
			makeReachableTo(task.getRealEntity());

			//			move(path)
		}

	}

	public void handleTask(SearchTask task) throws SOSActionException {
		log.debug("Handling task " + task);
		if (task == null) {
			log.info("Noting to do in Search???");
			return;
		} else {
			log.info("!!!!!!!!!!!!!KHODSUZI?!!!task ine="+task.getArea()+"    "+task);
			moveToShape(task.getArea());
		}
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub
		
	}

}
