package sos.police_v2.states;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

import sos.ambulance_v2.decision.AmbUtile;
import sos.base.SOSAgent;
import sos.base.entities.Building;
import sos.base.entities.Road;
import sos.base.entities.StandardEntity;
import sos.base.move.types.PoliceMove;
import sos.base.util.SOSActionException;
import sos.base.util.SOSGeometryTools;
import sos.base.util.geom.ShapeInArea;
import sos.police_v2.PoliceForceAgent;
import sos.search_v2.tools.cluster.ClusterData;
import be.abeel.util.Pair;

public class PoliceSearch extends PoliceAbstractState {
	int countercivreach = 0;
	int counter;
	ArrayList<Building> NeighbourClustersBuildings = new ArrayList<Building>();
	ArrayList<ClusterData> clusters = new ArrayList<ClusterData>();

	public PoliceSearch(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
//		log.error("in PoliceSearch");
		NeighbourClustersBuildings = new ArrayList<Building>();
		clusters = new ArrayList<ClusterData>();


		// TODO Auto-generated constructor stub
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub

	}

	@Override
	public void act() throws SOSActionException {
		int counter = 0;
//		if (countercivreach >= model().searchWorldModel.getClusterData().getBuildings().size())
//			 agent.BeginCivReach = true;
		log.info("in PoliceSearch");

		agent.BeginCivReach = true;
		if (model().getLastAfterShockTime() > 1)
			makeFalse();

		if (agent.searchBuildingTarget != null) {

			if (agent.getVisibleEntities(Building.class).contains(agent.searchBuildingTarget))
			{
				agent.searchBuildingTarget.setChecked(true);
				agent.searchBuildingTarget = null;
			}
			else {
				agent.move.moveToShape(agent.searchBuildingTarget.getSearchAreas(), PoliceMove.class);
			}
		}
		Building last = null;
		int myP = agent.myPlaceInGroup();
		for (Building b : model().searchWorldModel.getClusterData().getBuildings()) {
			last = b;
			if (b.getChecked()) {
//				countercivreach ++;
				continue;
				}
//
//			if (!isValid(b))
//				continue;

			if (myP != -1 && counter < myP) {
				counter++;
				continue;
			}

			agent.searchBuildingTarget = b;
			agent.move.moveToShape(b.getSearchAreas(), PoliceMove.class);
		}
		clusters.addAll(model().searchWorldModel.getAllClusters());
		Collections.sort(clusters, new DistanceComperatorDis(agent));

		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(0).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(1).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(2).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(3).getBuildings());
		NeighbourClustersBuildings.addAll(getArgumentSortedCluster(4).getBuildings());
		Collections.sort(NeighbourClustersBuildings, new BuildingDistanceComparator(agent));

		counter = 0;
		myP = agent.myPlaceInGroup();

		for (Building b : NeighbourClustersBuildings) {

			if (b == null) {
				continue;
			}

			if (b.getChecked()) {
				continue;
				
			}
			if ((b.getFieryness() > 0 && b.getFieryness() < 4) || b.getFieryness() == 8) {
				b.setChecked(true);
				continue;
			}
			if (myP != -1 && counter < myP) {
				counter++;
				last = b;
				continue;
			}
			agent.searchBuildingTarget = b;
			agent.move.moveToShape(b.getSearchAreas(), PoliceMove.class);

		}

		agent.move.moveToShape(last.getSearchAreas(), PoliceMove.class);

		// TODO Auto-generated method stub

	}

	public void makeFalse() {
		for (Building b : model().searchWorldModel.getClusterData().getBuildings()) {
			b.setChecked(false);
		}
	}

	private boolean isValid(Building b) {
		for (ShapeInArea sia : b.getSearchAreas())
			if (AmbUtile.isReallyReachableBuilding(sia.getArea(), true))
				return true;
		return false;
	}

	public ClusterData getArgumentSortedCluster(int i) {

		if (clusters.get(i) != null)
			return clusters.get(i);

		return null;

	}

}

class RoadComparator implements Comparator<Pair<Road, Integer>> {

	@Override
	public int compare(Pair<Road, Integer> o1, Pair<Road, Integer> o2) {

		if (o1.y() < o2.y())
			return -1;
		else if (o1.y() > o2.y())
			return 1;
		return 1;
	}

	// return -1 : go to the top. 

}

class DistanceComperatorDis implements Comparator<ClusterData> {

	private SOSAgent<? extends StandardEntity> agent = null;

	public DistanceComperatorDis(SOSAgent<? extends StandardEntity> agent) {
		this.agent = agent;
	}

	@Override
	public int compare(ClusterData o1, ClusterData o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}

class BuildingDistanceComparator implements Comparator<Building> {

	private SOSAgent<? extends StandardEntity> agent = null;

	public BuildingDistanceComparator(SOSAgent<? extends StandardEntity> agent) {
		this.agent = agent;
	}

	@Override
	public int compare(Building o1, Building o2) {
		double o1s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o1.getX(), o1.getY());
		double o2s = SOSGeometryTools.distance(agent.me().getPositionPoint().getX(), agent.me().getPositionPoint().getY(), o2.getX(), o2.getY());
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
}