package sos.police_v2.states;

import java.util.ArrayList;

import sos.base.entities.Building;
import sos.base.move.types.PoliceMove;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;
import sos.search_v2.tools.cluster.ClusterData;

public class PoliceSearchV2 extends PoliceAbstractState {

	ArrayList<ClusterData> clusters = new ArrayList<ClusterData>();
	ArrayList<Building> buildings;
	ArrayList<Building> myClusterBuildings;

	public PoliceSearchV2(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		log.error("in PoliceSearch");
		buildings = new ArrayList<Building>();
		myClusterBuildings = new ArrayList<Building>();
		// TODO Auto-generated constructor stub
	}

	@Override
	public void precompute() {
		// TODO Auto-generated method stub

	}

	@Override
	public void act() throws SOSActionException {
		setBuildings();
		if (agent.searchBuildingTarget != null) {

			if (agent.getVisibleEntities(Building.class).contains(agent.searchBuildingTarget))
			{
				agent.searchBuildingTarget.setChecked(true);
				agent.searchBuildingTarget = null;
			}
			else {
				agent.move.moveToShape(agent.searchBuildingTarget.getSearchAreas(), PoliceMove.class);
			}
		}
		
		if (myClusterBuildings.size() != 0) {
			agent.searchBuildingTarget = myClusterBuildings.get(0);
			agent.move.moveToShape(myClusterBuildings.get(0).getSearchAreas(), PoliceMove.class);
		}
		else 
		{
			agent.searchBuildingTarget = buildings.get(0);
			agent.move.moveToShape(buildings.get(0).getSearchAreas(), PoliceMove.class);
		
		}
	}

	public void setBuildings() {
		for (Building b : model().buildings())
			if (!b.getChecked())
				buildings.add(b);

		for (Building b : buildings)
			if (model().searchWorldModel.getClusterData().getBuildings().contains(b.getAreaPosition()))
				myClusterBuildings.add(b);

	}

}
