package sos.police_v2.states;

import java.awt.Shape;
import java.awt.geom.Point2D;
import java.util.ArrayList;

import sos.base.entities.Refuge;
import sos.base.util.SOSActionException;
import sos.police_v2.PoliceForceAgent;

public class RefugeState extends PoliceAbstractState {
	ArrayList<Refuge> refs = new ArrayList<Refuge>();
	boolean checkprec = false;
	public RefugeState(PoliceForceAgent policeForceAgent) {
		super(policeForceAgent);
		if(!checkprec){
			Shape myCluster = model().searchWorldModel.getClusterData()
					.getConvexShape();
			refs = new ArrayList<Refuge>();		
			for (Refuge refuge : model().refuges()) {
							if (isReachableTo(refuge))
								continue;
				

				if (myCluster.contains(new Point2D.Double(refuge.getX(), refuge
						.getY())))
					refs.add(refuge);
			}

		}
	}
	
	@Override
	public void precompute() {
		checkprec = true;
		Shape myCluster = model().searchWorldModel.getClusterData()
				.getConvexShape();
		refs = new ArrayList<Refuge>();		
		for (Refuge refuge : model().refuges()) {
						if (isReachableTo(refuge))
							continue;
			

			if (myCluster.contains(new Point2D.Double(refuge.getX(), refuge
					.getY())))
				refs.add(refuge);
		}

	}
	
	@Override
	public void act() throws SOSActionException {
		if(checkprec)
			log.info("PRECOM PRECOM PRECOM!!!!!!!!!!!!!!!!!!!!!!!!!!!");
			
		ArrayList<Refuge> reachableref = new ArrayList<Refuge>();

		if (refs.isEmpty()) {
			return;
		}

		for (Refuge refu : refs) {
			//log.warn("refs= "+refs.size());
			if (isReachableTo(refu)) {

				reachableref.add(refu);
			}
		}
		refs.removeAll(reachableref);

		if (refs.isEmpty()) {
			return;
		} 
		makeReachableTo(refs);

	}

}
