package sos.ambulance_v2.decision;

import java.util.Comparator;

import rescuecore2.misc.Pair;
import sos.base.entities.AmbulanceTeam;
import sos.base.entities.Area;
import sos.base.entities.Human;
import sos.base.util.SOSGeometryTools;
import sos.search_v2.tools.cluster.ClusterData;
public class AmbComparator{
	
}


/**
 * 
 * @author Saina Ghadiany
 *
 */

class RefugeComparator implements Comparator<Pair<Area,Integer>> {

	@Override
	public int compare(Pair<Area,Integer> ref1, Pair<Area,Integer> ref2) { //timeToRefuge\\
		if(ref1.second() < ref2.second())
			return -1;
		if(ref1.second() > ref2.second())
			return 1;
		
		return 0;
	}
}

class humanComparator implements Comparator<Pair<Human,Integer>>{
	@Override
	public int compare(Pair<Human, Integer> hm1, Pair<Human, Integer> hm2) {
		if(hm1.second() < hm2.second())
			return -1;
		if(hm1.second() > hm2.second())
			return 1;
		return 0;
	}
	
}

class clusterComparator implements Comparator<Pair<ClusterData,Float>>{

	@Override
	public int compare(Pair<ClusterData, Float> o1, Pair<ClusterData, Float> o2) {
		// TODO Auto-generated method stub
		if (o1.second() > o2.second())
			return -1;
		else if (o1.second() < o2.second())
			return 1;
		else if(o1.first().getY() > o2.first().getY())
			return -1;
		else
			return 1;

	}
}

class clusterComparitor implements Comparator<AmbulanceTeam> {

	private Human target = null;
	public clusterComparitor( Human target){
		this.target=target;
	}
	@Override
	public int compare(AmbulanceTeam o1, AmbulanceTeam o2) {
		ClusterData o1Cluster = o1.model().searchWorldModel.getClusterData(o1);
		ClusterData o2Cluster = o2.model().searchWorldModel.getClusterData(o2);
		double o1s = SOSGeometryTools.distance(target.getPositionPoint().getX(),target.getPositionPoint().getY(), o1Cluster.getX(), o1Cluster.getY());
		double o2s = SOSGeometryTools.distance(target.getPositionPoint().getX(), target.getPositionPoint().getY(), o2Cluster.getX(), o2Cluster.getY());
		
		if (o1s > o2s)
			return 1; //o2s
		if (o1s < o2s)
			return -1; //o1s
		return 0;
	}
	
}

//saaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaainaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\\



